/*
    Razkazhi za men na dushterya ti
    Kogato v skuta ti zaradi muzh zaplache
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;
const int MAXLOG = 15;
const int INF  = 1e9;

int parent[MAXN];
int depth[MAXN];
int back[MAXN];
bool vis[MAXN];
std::vector <int> g[MAXN];

void dfs(int node, int par)
{
    vis[node] = true;
    parent[node] = par;
    depth[node] = (node == 0 ? 0 : depth[par] + 1);
    for (const int &u : g[node])
    {
        if (par == u)
        {
            continue;
        }

        if (vis[u])
        {
            if (depth[u] > depth[node])
            {
                continue;
            }

            assert(back[node] == 0);
            back[node] = depth[node] - depth[u];
            continue;
        }

        dfs(u, node);
    }
}

std::vector <bool> sol;

void push(int num)
{
    for (int lg = MAXLOG - 1 ; lg >= 0 ; --lg)
    {
        sol.push_back(num & (1 << lg));
    }
}

std::vector <bool> encode(int n, std::vector <std::pair <int,int>> edges)
{
    sol.clear();
    for (int i = 0 ; i < n ; ++i)
    {
        parent[i] = depth[i] = back[i] = vis[i] = 0;
    }

    for (int i = 0 ; i < edges.size() ; ++i)
    {
        g[edges[i].first].push_back(edges[i].second);
        g[edges[i].second].push_back(edges[i].first);
    }

    dfs(0, -1);
    for (int i = 1 ; i < n ; ++i)
    {
        push(parent[i]);
    }

    for (int i = 1 ; i < n ; ++i)
    {
        for (int j = 0 ; j < back[i] ; ++j)
        {
            sol.push_back(1);
        }

        sol.push_back(0);
    }

    return sol;
}

std::vector <std::pair <int,int>> decode(int n, std::vector <bool> data)
{
    int ptr = 0;
    parent[0] = -1;
    std::vector <std::pair <int,int>> answer;
    for (int i = 1 ; i < n ; ++i)
    {
        int p = 0;
        for (int j = 0 ; j < MAXLOG ; ++j)
        {
            p <<= 1;
            p += data[ptr++];
        }

        parent[i] = p;
        answer.push_back({p, i});
    }

    for (int i = 1 ; i < n ; ++i)
    {
        int node = i;
        while (data[ptr] == 1)
        {
            node = parent[node];
            ptr++;
        }

        ptr++;
        if (i != node) answer.push_back({i, node});
    }

    return answer;
}