/*
    Razkazhi za men na dushterya ti
    Kogato v skuta ti zaradi muzh zaplache
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>

typedef long long llong;
const int MAXN = 5e5 + 10;
const llong INF = 1e18;

int n;
int a[MAXN];

struct Range
{
    llong value;
    int l, r;
    int optL, optR;
    bool type;

    friend bool operator < (const Range &a, const Range &b)
    {
        return a.value < b.value;
    }
};

std::priority_queue <Range> pq;
struct Triplet
{
    llong value;
    int l, r;
};

Triplet findOpt(int l, int r, bool type) // 0 -> +-, 1 -> -+
{
    if (type == 0)
    {
        llong ans = -INF;
        int min = a[r];
        int minIdx = r;
        int idxL, idxR;
        for (int i = r - 1 ; i >= l ; --i)
        {
            if (ans < a[i] - min)
            {
                ans = a[i] - min;
                idxL = i;
                idxR = minIdx;
            }

            if (min > a[i])
            {
                min = a[i];
                minIdx = i;
            }
        }

        return {ans, idxL, idxR};
    } else
    {
        llong ans = -INF;
        int min = a[l];
        int minIdx = l;
        int idxL, idxR;
        for (int i = l + 1 ; i <= r ; ++i)
        {
            if (ans < a[i] - min)
            {
                ans = a[i] - min;
                idxR = i;
                idxL = minIdx;
            }

            if (min > a[i])
            {
                min = a[i];
                minIdx = i;
            }
        }

        return {ans, idxL, idxR};
    }
}

void solve()
{
    Triplet initial = findOpt(1, n, 1);
    pq.push({initial.value, 0, n + 1, initial.l, initial.r, 1});

    int ptr = 1;
    llong ans = 0;
    while (pq.size() && pq.top().value > 0)
    {
        auto [val, borderL, borderR, idxL, idxR, type] = pq.top();
        pq.pop();

        ans += val;
        ptr++;
        std::cout << ans << ' ';
        if (borderL + 2 < idxL)
        {
            Triplet curr = findOpt(borderL + 1, idxL - 1, type);
            pq.push({curr.value, borderL, idxL, curr.l, curr.r, type});
        }

        if (idxL + 2 < idxR)
        {
            Triplet curr = findOpt(idxL + 1, idxR - 1, type ^ 1);
            pq.push({curr.value, idxL, idxR, curr.l, curr.r, type ^ 1});
        }

        if (idxR + 2 < borderR)
        {
            Triplet curr = findOpt(idxR + 1, borderR - 1, type ^ 1);
            pq.push({curr.value, idxR, borderR, curr.l, curr.r, type ^ 1});
        }
    }

    while (ptr <= n)
    {
        std::cout << ans << ' ';
        ptr++;
    }

    std::cout << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}