/*
    Razkazhi za men na dushterya ti
    Kogato v skuta ti zaradi muzh zaplache
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 1e7 + 10;
const int MOD = 1e9 + 7;

int n;
int f[MAXN];
char s[MAXN];

inline llong power(llong a)
{
    const int b = MOD - 2;
    llong res = 1;
    for (int lg = 0 ; lg < 30 ; ++lg)
    {
        if (b & (1 << lg))
        {
            res *= a;
            res %= MOD;
        }

        a *= a;
        a %= MOD;
    }

    return res;
}

struct Equation
{
    int vals[MAXN];
    int equalTo;
    int mult;
    int multInv;
    
    Equation()
    {
        equalTo = 0;
        std::fill(vals, vals + MAXN, 0);
    }

    void addToValue(int idx, int value)
    {
        vals[idx] = (vals[idx] + 1LL * value * multInv) % MOD;
    }

    void addToEqualTo(int value)
    {
        equalTo = (equalTo + 1LL * value * multInv) % MOD;
    }

    int howMuchIsValue(int idx)
    {
        return (1LL * vals[idx] * mult) % MOD;
    }

    int howMuchIsEqualTo()
    {
        return (1LL * equalTo * mult) % MOD;
    }
};

Equation eq;
int withOne[MAXN];
int withZero[MAXN];
int newF[MAXN];
int pA, pB;
void solve()
{
    f[1] = 0;
    for (int i = 2 ; i <= n ; ++i)
    {
        f[i] = f[i - 1];
        while (s[f[i] + 1] != s[i])
        {
            if (f[i] == 0)
            {
                break;
            }

            f[i] = f[f[i]];
        }

        if (s[f[i] + 1] == s[i])
        {
            f[i]++;
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        withOne[i] = withOne[f[i]];
        withZero[i] = withZero[f[i]];
        if (s[f[i] + 1] == '0')
        {
            withOne[i] = i;
        } else
        {
            withZero[i] = i;
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        newF[i] = f[i];
        if (s[i + 1] == '0')
        {
            newF[i] = f[withZero[i]];
        } else
        {
            newF[i] = f[withOne[i]];
        }

        if (s[newF[i] + 1] != s[i + 1])
        {
            newF[i]++;
        }
    }

    int p0 = (pA * power(pB)) % MOD;
    int p1 = ((pB - pA) * power(pB)) % MOD;
    int p0inv = power(p0);
    int p1inv = power(p1);

    eq.mult = 1;
    eq.multInv = 1;
    eq.vals[n] = 1;
    eq.equalTo = 0;

    for (int i = n - 1 ; i >= 0 ; --i)
    {
        eq.addToValue(i + 1, -1);
        eq.mult = (1LL * eq.mult * (s[i + 1] == '0' ? p0 : p1)) % MOD;
        eq.multInv = (1LL * eq.multInv * (s[i + 1] == '0' ? p0inv : p1inv)) % MOD;

        eq.addToEqualTo(1);
        eq.addToValue(newF[i], (MOD - (s[i + 1] == '1' ? p0 : p1)));
        eq.addToValue(i, 1);

        int val = eq.howMuchIsValue(i);
        eq.mult = (1LL * eq.mult * power(val)) % MOD;
        eq.multInv = (1LL * eq.multInv * val) % MOD;
    }

    std::cout << eq.howMuchIsEqualTo() << '\n';
}

void input()
{
    std::cin >> n;
    std::cin >> pA >> pB;
    std::cin >> s + 1;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}