/*
    Razkazhi za men na dushterya ti
    Kogato v skuta ti zaradi muzh zaplache
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 1e7 + 10;
const int MOD = 1e9 + 7;
const int MAXLOG = 14;

int n;
int f[MAXN];
char s[MAXN];

llong power(llong a, llong b)
{
    if (b == 0)
    {
        return 1;
    }

    if (b & 1)
    {
        return (a * power(a, b - 1)) % MOD;
    }

    llong res = power(a, b / 2);
    return (res * res) % MOD;
}

struct Equation
{
    llong vals[MAXN];
    llong equalTo;
    llong mult;
    llong multInv;
    
    Equation()
    {
        equalTo = 0;
        std::fill(vals, vals + MAXN, 0);
    }

    void operator *= (llong value)
    {
        mult *= value;
        mult %= MOD;
        multInv *= power(value, MOD - 2);
        multInv %= MOD;
    }

    void addToValue(int idx, llong value)
    {
        vals[idx] = (vals[idx] + value * multInv) % MOD;
    }

    void addToEqualTo(llong value)
    {
        equalTo = (equalTo + value * multInv) % MOD;
    }

    llong howMuchIsValue(int idx)
    {
        return (vals[idx] * mult) % MOD;
    }

    llong howMuchIsEqualTo()
    {
        return (equalTo * mult) % MOD;
    }
};

Equation eq;
int newF[MAXN];
int pA, pB;
void solve()
{
    f[1] = 0;
    for (int i = 2 ; i <= n ; ++i)
    {
        f[i] = f[i - 1];
        while (s[f[i] + 1] != s[i])
        {
            if (f[i] == 0)
            {
                break;
            }

            f[i] = f[f[i]];
        }

        if (s[f[i] + 1] == s[i])
        {
            f[i]++;
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        newF[i] = f[i];
        while (s[newF[i] + 1] == s[i + 1])
        {
            if (newF[i] == 0)
            {
                break;
            }

            newF[i] = f[newF[i]];
        }

        if (s[newF[i] + 1] != s[i + 1])
        {
            newF[i]++;
        }
    }

    llong p0 = (pA * power(pB, MOD - 2)) % MOD;
    llong p1 = ((pB - pA) * power(pB, MOD - 2)) % MOD;
    llong p0inv = power(p0, MOD - 2);
    llong p1inv = power(p1, MOD - 2);

    eq.mult = 1;
    eq.multInv = 1;
    eq.vals[n] = 1;
    eq.equalTo = 0;

    for (int i = n - 1 ; i >= 0 ; --i)
    {
        eq.addToValue(i + 1, -1);
        eq.mult = (eq.mult * (s[i + 1] == '0' ? p0 : p1)) % MOD;
        eq.multInv = (eq.multInv * (s[i + 1] == '0' ? p0inv : p1inv)) % MOD;

        eq.addToEqualTo(1);
        eq.addToValue(newF[i], (MOD - (s[i + 1] == '1' ? p0 : p1)));
        eq.addToValue(i, 1);

        llong val = eq.howMuchIsValue(i);
        eq.mult = (eq.mult * power(val, MOD - 2)) % MOD;
        eq.multInv = (eq.multInv * val) % MOD;
    }

    std::cout << eq.howMuchIsEqualTo() << '\n';
}

void input()
{
    std::cin >> n;
    std::cin >> pA >> pB;
    std::cin >> s + 1;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}