#include<bits/stdc++.h>

#include "cactus.h"

#define MAXN 100007
using namespace std;

int n,upe[MAXN];
vector<int> v[MAXN];

vector<bool> code;
int vis[MAXN],parent[MAXN];

stack<int> st;
vector< pair<int,int> > ans,g[MAXN];

int backedge[MAXN];

void reset(){
    code.clear();

    for(int i=0;i<n;i++){
        vis[i]=0; v[i].clear();
        backedge[i]=-1;
        g[i].clear();
        parent[i]=0;
        upe[i]=0;
    }

    ans.clear();
    while(!st.empty())st.pop();
}

vector<bool> encod(int x){
    vector<bool> res;

    for(int i=13;i>=0;i--){
        res.push_back( (((1<<i)&x) > 0) );
    }

    return res;
}

void add(int x){
    auto res=encod(x);
    for(bool x:res)code.push_back(x);
}

void mark(int x,int y){
    if(x==y)return;

    backedge[x]=y;
    mark(parent[x],y);
}

void dfs(int x,int par){
    vis[x]=1;
    parent[x]=par;

    for(int i:v[x]){
        if(vis[i]==0){
            dfs(i,x);
        }else if(i!=par and vis[i]==1){
            mark(x,i);
        }
    }

    vis[x]=2;
}

void dfs2(int x,int a,int b){
    vis[x]=3;

    for(int i:v[x]){

        if(vis[i]==3)continue;

        if(backedge[i]==-1){
            upe[i]=0;

            dfs2(i,0,0);
        }else{
            if(backedge[x]==backedge[i]){
                upe[i]=2*a+b;
                
                dfs2(i,a,b);
            }else{
                if(a==0 and b==0)a=1;
                
                upe[i]=2*(1-a)+(1-b);

                dfs2(i,1-a,1-b);
            }
        }
    }
}

vector<bool> encode(int N, vector< pair<int, int> > edges){
    n=N;
    reset();

    for(int i=0;i<edges.size();i++){
        v[edges[i].first].push_back(edges[i].second);
        v[edges[i].second].push_back(edges[i].first);
    }

    dfs(0,0);

    for(int i=1;i<n;i++){
        add(parent[i]);
    }

    dfs2(0,0,0);

    for(int i=1;i<n;i++){
        code.push_back(upe[i]/2);
        code.push_back(upe[i]%2);
    }

    return code;
}

void addedge(int x,int y,int z){
    g[x].push_back({y,z});
    g[y].push_back({x,z});
}

void adde(int x,int y){
    ans.push_back({x,y});
}

void dfs3(int x,int p,int c,int up){

    int br=0;
    for(auto nxt:g[x]){
        if(nxt.first==p)continue;

        adde(x,nxt.first);

        if(nxt.second==0){
            dfs3(nxt.first,x,0,0);
        }else if(nxt.second==c){
            br++;
            dfs3(nxt.first,x,c,up);
        }else{
            dfs3(nxt.first,x,nxt.second,x);
        }
    }

    if(c!=0 and br==0){
        adde(x,up);
    }
}

vector< pair<int, int> > decode(int N, vector<bool> data){
    n=N;
    reset();

    int pos=0;
    for(int i=1;i<n;i++){
        int news=0;
        for(int f=pos;f<=pos+13;f++){
            news*=2;
            if(data[f])news++;
        }

        parent[i]=news;
        pos+=14;
    }

    for(int i=1;i<n;i++){

        int news=0;
        for(int f=pos;f<=pos+1;f++){
            news*=2;
            if(data[f])news++;
        }
        
        upe[i]=news;
        pos+=2;
    }

    for(int i=1;i<n;i++){
        addedge(parent[i],i,upe[i]);
    }

    dfs3(0,0,0,0);

    return ans;
}
