#include<bits/stdc++.h>
#define MAXN 10000007
using namespace std;

const long long mod=1e9+7;

struct frac{
    long long p,q;

    inline friend frac operator + (frac fr,frac sc){
        return {(fr.p*sc.q+fr.q*sc.p)%mod,(fr.q*sc.q)%mod};
    }

    inline friend frac operator * (frac fr,frac sc){
        return {(fr.p*sc.p)%mod , (fr.q*sc.q)%mod};
    }
};

frac neg(frac x){
    return {(mod-x.p)%mod,x.q};
}

frac inv(frac x){
    return {x.q,x.p};
}

int n;
int pa,pb;

char s[MAXN];

pair<frac,frac> e;

long long power(long long a,long long b){
    if(b==0)return 1;
    if(b==1)return a%mod;
    if(b==2)return (a*a)%mod;

    if(b%2==0)return power(power(a,b/2),2);
    return (power(power(a,b/2),2)*a)%mod;   
}

pair<frac,frac> B[MAXN];
int matches[MAXN],fail[MAXN];

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>pa>>pb;
    cin>>(s+1);

    for(int i=2;i<=n;i++){
        int curr=fail[i-1];

        while(curr>0 and s[curr+1]!=s[i]){
            curr=fail[curr];
        }

        if(s[curr+1]==s[i])curr++;

        fail[i]=curr;
    }

    for(int i=0;i<=n-1;i++){
        char nxt=s[i+1];
        if(nxt=='0')nxt='1';
        else nxt='0';

        int curr=i;
        while(curr>0 and s[curr+1]!=nxt){
            curr=fail[curr];
        }

        if(s[curr+1]==nxt){
            curr++;
        }

        matches[i]=curr;
    }

    B[0]={{1,1},{0,1}};

    frac zero={pa,pb};
    frac one={pb-pa,pb};

    if(s[1]=='0')B[1]={{1,1},neg(inv(zero))};
    else B[1]={{1,1},neg(inv(one))};
    
    for(int i=2;i<=n;i++){
        frac curr;

        if(s[i]=='0')curr=zero;
        else curr=one;

        int to=matches[i-1];

        B[i].first = (B[i-1].first + (curr*B[to].first) + neg(B[to].first)) * inv(curr);
        B[i].second = (B[i-1].second + (curr*B[to].second) + neg(B[to].second) + neg({1,1})) * inv(curr);
    }

    e=B[n];
    e.second=neg(e.second);

    e.second = e.second*inv(e.first);
    
    cout<<( e.second.p * power(e.second.q,mod-2) )%mod<<"\n";



    return 0;
}