#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
const int MAX_N=1e5;
const int LOG=14;
int parent[MAX_N];
bool usededge[MAX_N];
bool treeedge[MAX_N];
int paredge[MAX_N];
bool used[MAX_N];
int depth[MAX_N];
vector<pair<int,int>>g[MAX_N];
vector<vector<int>>cycles;
int p[MAX_N][LOG];
void dfs(int u)
{
    used[u]=1;
    for(auto [v,edge]:g[u])
    {
        if(usededge[edge])continue;
        if(used[v])continue;
        treeedge[edge]=1;
        parent[v]=u;
        depth[v]=depth[u]+1;
        paredge[v]=edge;
        dfs(v);
    }
}
int lca(int a,int b)
{
    if(depth[a]>depth[b])swap(a,b);

    for(int j=LOG-1;j>=0;j--)
    {
        if(depth[b]-(1<<j)>=depth[a])
        {
            b=p[b][j];
        }
    }

    if(a==b)return a;

    for(int j=LOG-1;j>=0;j--)
    {
        if(p[a][j]!=p[b][j])
        {
            a=p[a][j];
            b=p[b][j];
        }
    }

    return p[a][0];
}
vector<bool>ans;
void pushans(int x,bool f)
{
    for(int j=13+f;j>=0;j--)
    {
        if(((1<<j)&(x))!=0)ans.push_back(1);
        else ans.push_back(0);
    }
}
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    ans.clear();
    cycles.clear();
    for(int i=1;i<=n;i++)g[i].clear();
    for(int i=1;i<=n;i++)used[i]=0;

    int m=edges.size();

    for(int i=1;i<=m;i++)
    {
        usededge[i]=0;
        treeedge[i]=0;
    }

    for(int i=0;i<edges.size();i++)
    {
        int u=edges[i].first,v=edges[i].second;
        g[u].push_back({v,i+1});
        g[v].push_back({v,i+1});
    }

    dfs(1);

    for(int i=1;i<=n;i++)
    {
        p[i][0]=parent[i];
    }

    for(int j=1;j<LOG;j++)
    {
        for(int i=1;i<=n;i++)
        {
            p[i][j]=p[p[i][j-1]][j-1];
        }
    }

    for(int i=1;i<=m;i++)
    {
        if(treeedge[i])continue;

        usededge[i]=1;

        int u=edges[i-1].first,v=edges[i-1].second;

        int lc=lca(u,v);

        vector<int>curcycle;

        while(u!=lc)
        {
            usededge[paredge[u]]=1;
            curcycle.push_back(u);
            u=parent[u];
        }

        curcycle.push_back(lc);

        reverse(curcycle.begin(),curcycle.end());

        while(v!=lc)
        {
            usededge[paredge[v]]=1;
            curcycle.push_back(v);
            v=parent[v];
        }

        cycles.push_back(curcycle);
    }

    for(int i=1;i<=n;i++)
    {
        used[i]=0;
        parent[i]=0;
    }

    for(int i=1;i<=n;i++)
    {
        if(used[i]==0)dfs(i);
    }

    pushans(cycles.size(),0);
    for(auto cyc:cycles)
    {
        for(int i=0;i<cyc.size();i++)
        {
            int u=cyc[i];
            pushans(2*u+(i<cyc.size()-1 ? 1 : 0),1);
        }
    }

    for(int i=1;i<=n;i++)
    {
        if(parent[i]==0)ans.push_back(0);
        else ans.push_back(1);
    }

    for(int i=1;i<=n;i++)
    {
        if(parent[i]==0)continue;

        pushans(parent[i],0);
    }

    return ans;
}
vector<pair<int,int>>ansg;
void add(int u,int v)
{
    ansg.push_back({u,v});
}
std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    int cntcycles=0;

    for(int b=0;b<14;b++)
    {
        int bit=14-b;

        if(data[b])cntcycles+=(1<<bit);
    }

    int curpos=14;
    int prevnode=-1;
    int startnode=-1;

    while(cntcycles>0)
    {
        int curnode=0;

        for(int b=curpos;b<curpos+15;b++)
        {
            int bit=14-(b-curpos);

            if(data[b])curnode+=(1<<bit);
        }

        curpos+=15;

        if(prevnode!=-1)
        {
            add(prevnode,curnode/2);
        }

        if(curnode%2==0)
        {
            add(curnode/2,startnode);
            prevnode=-1;

            cntcycles--;

            if(cntcycles==0)break;
        }


        if(curnode%2==1)
        {
            prevnode=curnode/2;
        }
        if(prevnode==-1)
        {
            startnode=curnode/2;
        }
    }

    vector<int>nodes;

    for(int b=curpos;b<curpos+n;b++)
    {
        if(data[b])nodes.push_back(b);
    }

    curpos+=n;
    int pos=0;

    while(curpos<data.size())
    {
        int curnode=0;

        for(int b=curpos;b<curpos+14;b++)
        {
            int bit=13-(b-curpos);

            if(data[b])curnode+=(1<<bit);
        }

        add(nodes[pos++],curnode);

        curpos+=14;
    }

    return ansg;
}


