#include "cactus.h"
#include<bits/stdc++.h>

using namespace std;

const int MAXN=16005;
int TREE=(1<<14)-1;
int CYC=(1<<14)-2;
int NULLVERT=(1<<14)-3;

int n;
int lg;
vector<bool> v;
vector<int> adj[MAXN];
bool toS[MAXN];
set<int> par[MAXN];
bool used[MAXN];
int col[MAXN];


int targ=-1;
bool fl=0;
vector<int> cyc;
vector<int> tree;

set<pair<int,int> > fe;

void dfsC(int v,int prv)
{
    tree.push_back(v);
    col[v]=1;
    for(int i=0;i<adj[v].size();i++)
    {
        int u=adj[v][i];
        if(!toS[u] || u==prv) continue; ///
        if(col[u]==1)
        {
            targ=u;
            fl=1;
            toS[v]=0;
            cyc.push_back(v);
            col[v]=0;
            for(int j=0;j<adj[v].size();j++) par[adj[v][j]].insert(v);
            return;
        }
        par[u].insert(v);
        dfsC(u,v);
        if(fl==2) return;
        if(fl)
        {
            cyc.push_back(v);
            for(int j=0;j<adj[v].size();j++) par[adj[v][j]].insert(v);
            toS[v]=0;
            col[v]=0;
            if(v==targ) fl=2;
            return;
        }
    }
    col[v]=0; ///
}

void dfs2(int v,int prv)
{
    toS[v]=0;
    for(auto u: adj[v])
    {
        if(toS[u]==0) continue;
        if(prv==u) continue;
        par[u].insert(v);
        dfs2(u,v);
    }
}

void add(int x)
{
    //cout<<v.size()<<" "<<x<<" ";
    for(int i=0;i<lg;i++)
    {
        if(x&(1<<i)) v.push_back(1);
        else v.push_back(0);
    }
    //for(auto x: v) cout<<x; cout<<endl;
}

void addf(int x,int y)
{
    fe.insert({min(x,y), max(x,y)});
}

set<int> bTree;
void addTree()
{
    for(auto x: tree)
    {
        bTree.insert(x);
    }
}

void addCyc()
{
    add(CYC); //cout<<"adding CYC "<<CYC<<endl;
    for(auto x: cyc)
    {
        add(x);
    }
    addf(cyc[0], cyc.back());
    for(int i=1;i<cyc.size();i++)
    {
        addf(cyc[i], cyc[i-1]);
    }
}

void addBtree()
{
    //sort(bTree.begin(), bTree.end());
    //for(auto x: bTree) cout<<x<<" "; cout<<endl;
    add(TREE);
    for(auto x: bTree)
    {
        add(NULLVERT);
        for(auto y: par[x]) add(y);
        for(auto y: par[x]) addf(x,y);
    }
}

void solve()
{
    bTree.clear();
    for(int i=0;i<n;i++)
    {
        if(toS[i]==1)
        {
            cyc.clear();
            tree.clear();
            fl=0;
            targ=-1;
            dfsC(i,-1);
            if(fl==0) addTree();
            else addCyc();
        }
    }
    for(int i=0;i<n;i++)
    {
        if(toS[i])
        {
            dfs2(i,-1);
            // int x=par[i].size();
            // if(x==0) dfs2(x,-1);
            // else if(toS[x]==0) dfs2(x,-1);
        }
    }
    addBtree();
}

std::vector<bool> encode(int _n, std::vector<std::pair<int, int>> edges)
{//cout<<44444<<endl;
    n=_n;
    lg=1;
    while(_n>1)
    {
        lg++;
        _n/=2;
    }
    v.clear();
    for(int i=0;i<n;i++) adj[i].clear();
    for(int i=0;i<n;i++) par[i].clear();
    for(int i=0;i<n;i++) col[i]=0;

    /*if(lg<=14)
    {
    TREE=(1<<lg)+1;
    CYC=(1<<lg)+2;
    NULLVERT=(1<<lg)+3;
    lg++;
    }*/

    for(auto [u,v]: edges)
    {
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for(int i=0;i<n;i++) toS[i]=1;
    solve();

//cout<<v.size()<<endl;
//for(auto x: v) cout<<x; cout<<endl;

add(TREE);
    for(auto [u,v]: edges)
    {
        if(u>v) swap(u,v);
        if(fe.count({u,v})==0) 
        {
            add(u);
            add(v);
        } 
    }

    return v;
}

vector<int> info;
vector<int> rest;
set<pair<int,int> > edge;
vector<pair<int,int> > ans;

void addEdge(int x,int y)
{
    if(x>y) swap(x,y);
    used[x]=used[y]=1;
    edge.insert({x,y});
}

std::vector<std::pair<int, int>> decode(int _n, std::vector<bool> data)
{//cout<<555<<endl;
    n=_n;
    lg=1;
    while(_n>1)
    {
        lg++;
        _n/=2;
    }
    //lg++;
    edge.clear();
    info.clear();
    rest.clear();
    ans.clear();
    for(int i=0;i<n;i++) used[i]=0;
//cout<<3232<<endl;
    int cnt=data.size()/(lg);
    for(int i=0;i<cnt;i++)
    {
        int cur=0;
        for(int j=0;j<lg;j++)
        {
            if(data[i*lg+j]==1) cur+=(1<<j);
        }
        info.push_back(cur);
    }
    //for(int i=0;i<cnt;i++) cout<<info[i]<<" "; cout<<endl;
//cout<<"sss"<<endl;
int rl=0;
    for(int i=0;i<cnt;i++)
    {
        //cout<<i<<endl;
        if(info[i]==CYC)
        {
            cyc.clear();
            i++;
            while(i<cnt && info[i]!=CYC && info[i]!=TREE)
            {
                cyc.push_back(info[i]);
                i++;
            }
            i--;
            addEdge(cyc[0], cyc.back());
            for(int j=1;j<cyc.size();j++) addEdge(cyc[j-1], cyc[j]);
            continue;
        }
        if(info[i]==TREE)
        {
            for(int j=0;j<n;j++)
            {
                if(!used[j]) rest.push_back(j);
            }
            i++;
            int ptr=-1;
            while(i<cnt && info[i]!=TREE)
            {
                if(info[i]==NULLVERT)
                {
                    ptr++;
                    i++;
                    continue;
                }
                int u=rest[ptr];
                int pu=info[i];
                addEdge(u,pu);
                i++;
            }
            rl=i;
            break;
        }

    }

    rl++;
    while(rl<cnt)
    {
        int u=info[rl];
        rl++;
        int v=info[rl];
        rl++;
        addEdge(u,v);
    }

    for(auto cur: edge) ans.push_back(cur);
    return ans;

}
/*
1
11 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10
*/