#include "cactus.h"
#include<bits/stdc++.h>

using namespace std;

const int MAXN=16005;
const int TREE=(1<<14)-1;
const int CYC=(1<<14)-2;
const int NULLVERT=(1<<14)-3;

int n;
int lg;
vector<bool> v;
vector<pair<int,int> > edge;
vector<int> adj[MAXN];
bool toS[MAXN];
int par[MAXN];
bool used[MAXN];
int col[MAXN];

void dfs(int v)
{
    used[v]=1;
    for(auto u: adj[v])
    {
        if(used[u]) continue;
        par[u]=v;
        dfs(u);
    }
}

int targ=-1;
bool fl=0;
vector<int> cyc;
vector<int> tree;
void dfsC(int v)
{
    tree.push_back(v);
    col[v]=1;
    for(int i=0;i<adj[v].size();i++)
    {
        int u=adj[v][i];
        if(!toS[u] || col[u]==2) continue; ///
        if(col[u]==1)
        {
            targ=u;
            fl=1;
            toS[v]=0;
            cyc.push_back(v);
            col[v]=0;
            for(int j=0;j<adj[v].size();j++) par[adj[v][j]]=v;
            return;
        }
        par[u]=v;
        dfsC(u);
        if(fl==2) return;
        if(fl)
        {
            cyc.push_back(v);
            for(int j=0;j<adj[v].size();j++) par[adj[v][j]]=v;
            toS[v]=0;
            col[v]=0;
            if(v==targ) fl=2;
            return;
        }
    }
    col[v]=0; ///
}

void dfs2(int v)
{
    for(auto u: adj[v])
    {
        if(toS[u]==0) continue;
        if(par[v]==u) continue;
        par[u]=v;
        dfs2(u);
    }
}

void add(int x)
{
    for(int i=0;i<lg;i++)
    {
        if(x&(1<<i)) v.push_back(1);
        else v.push_back(0);
    }
}

vector<int> bTree;
void addTree()
{
    for(auto x: tree)
    {
        bTree.push_back(x);
    }
}

void addCyc()
{
    add(CYC);
    for(auto x: cyc)
    {
        add(x);
    }
}

void addBtree()
{
    sort(bTree.begin(), bTree.end());
    add(TREE);
    for(auto x: bTree)
    {
        if(par[x]!=-1) add(par[x]);
        else add(NULLVERT);
    }
}

void solve()
{
    for(int i=0;i<n;i++)
    {
        if(toS[i]==1)
        {
            cyc.clear();
            tree.clear();
            fl=0;
            targ=-1;
            dfsC(i);
            if(fl==0) addTree();
            else addCyc();
        }
    }
    for(int i=0;i<n;i++)
    {
        if(toS[i])
        {
            int x=par[i];
            if(x==-1) dfs2(x);
            else if(toS[x]==0) dfs2(x);
        }
    }
    addBtree();
}

std::vector<bool> encode(int _n, std::vector<std::pair<int, int>> edges)
{//cout<<44444<<endl;
    n=_n;
    lg=1;
    while(_n>1)
    {
        lg++;
        _n/=2;
    }
    v.clear();
    for(int i=0;i<n;i++) adj[i].clear();
    for(int i=0;i<n;i++) par[i]=-1;
    for(int i=0;i<n;i++) col[i]=0;

    for(auto [u,v]: edges)
    {
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for(int i=0;i<n;i++) toS[i]=1;
    solve();

    return v;
}

vector<int> info;
vector<int> rest;

void addEdge(int x,int y)
{
    used[x]=used[y]=1;
    edge.push_back({x,y});
}

std::vector<std::pair<int, int>> decode(int _n, std::vector<bool> data)
{//cout<<555<<endl;
    n=_n;
    lg=1;
    while(_n>1)
    {
        lg++;
        _n/=2;
    }
    edge.clear();
    info.clear();
    rest.clear();
    for(int i=0;i<n;i++) used[i]=0;
//cout<<3232<<endl;
    int cnt=data.size()/(lg);
    for(int i=0;i<cnt;i++)
    {
        int cur=0;
        for(int j=0;j<lg;j++)
        {
            if(data[i*lg+j]==1) cur+=(1<<j);
        }
        info.push_back(cur);
    }
//cout<<"sss"<<endl;
    for(int i=0;i<cnt;i++)
    {
        //cout<<i<<endl;
        if(info[i]==CYC)
        {
            cyc.clear();
            i++;
            while(i<cnt && info[i]!=CYC && info[i]!=TREE)
            {
                cyc.push_back(info[i]);
                i++;
            }
            i--;
            addEdge(cyc[0], cyc.back());
            for(int j=1;j<cyc.size();j++) addEdge(cyc[j-1], cyc[j]);
            continue;
        }
        if(info[i]==TREE)
        {
            for(int j=0;j<n;j++)
            {
                if(!used[j]) rest.push_back(j);
            }
            i++;
            int ptr=0;
            while(i<cnt)
            {
                int u=rest[ptr++];
                int pu=info[i];
                addEdge(u,pu);
                i++;
            }
        }
    }

    return edge;
}
/*
1
11 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10
*/