#include "cactus.h"
#include<bits/stdc++.h>

using namespace std;

const int MAXN=16005;

int n;
vector<bool> v;
vector<pair<int,int> > edge;
vector<int> adj[MAXN];
int par[MAXN];

void dfs(int v)
{
    for(auto u: adj[v])
    {
        if(u==par[v]) continue;
        par[u]=v;
        dfs(u);
    }
}

std::vector<bool> encode(int _n, std::vector<std::pair<int, int>> edges)
{//cout<<44444<<endl;
    n=_n;
    int lg=1;
    while(_n>1)
    {
        lg++;
        _n/=2;
    }
    v.clear();
    for(int i=0;i<n;i++) adj[i].clear();
    for(int i=0;i<n;i++) par[i]=-1;

    for(auto cur: edges)
    {
        adj[cur.first].push_back(cur.second);
        adj[cur.second].push_back(cur.first);
    }
    par[0]=-1;
    dfs(0);
    //cout<<1234<<endl;

    for(int i=1;i<n;i++)
    {
        for(int j=0;j<lg;j++)
        {
            if(par[i]&(1<<j)) v.push_back(1);
            else v.push_back(0);
        }
    }
//cout<<7777<<endl;
    for(auto cur: edges)
    {
        auto [u,w]=cur;
        if(par[u]==w || par[w]==u) continue;
        for(int i=0;i<lg;i++)
        {
            if(u&(1<<i)) v.push_back(1);
            else v.push_back(0);
        }
        for(int i=0;i<lg;i++)
        {
            if(w&(1<<i)) v.push_back(1);
            else v.push_back(0);
        }
    }
    //cout<<9999<<endl;
    return v;
}

std::vector<std::pair<int, int>> decode(int _n, std::vector<bool> data)
{//cout<<555<<endl;
    n=_n;
    int lg=1;
    while(_n>1)
    {
        lg++;
        _n/=2;
    }
    edge.clear();

    for(int i=1;i<n;i++)
    {
        int u=0;
        for(int j=0;j<lg;j++)
        {
            if(data[(i-1)*lg+j]==1) u+=(1<<j);
        }
        edge.push_back({i,u});
    }

    int cnt=(data.size()-(n-1)*lg)/(2*lg);
    int C=(n-1)*lg+1;
    for(int i=0;i<cnt;i++)
    {
        int u=0;
        for(int j=0;j<lg;j++)
        {
            if(data[C+2*i*lg+j]==1) u+=(1<<j);
        }
        int w=0;
        for(int j=0;j<lg;j++)
        {
            if(data[C+(2*i+1)*lg+j]==1) w+=(1<<j);
        }
        edge.push_back({u,w});
    }
    return edge;
}
/*
1
31 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10
*/