#include<bits/stdc++.h>
#include "cactus.h"

#define MAXN 16006

using namespace std;

unordered_multiset<int> M[MAXN];
int N, c, s;
vector<int> odd;
unordered_set<long long> additional;
vector<bool> vec;
unordered_set<long long> ans;
bool ps[MAXN];

void createAdj(vector<pair<int, int> >& edges)
{
    for(auto edge : edges)
    {
        M[edge.first].insert(edge.second);
        M[edge.second].insert(edge.first);
    }
}
void addBits(int n)
{
    for(int i = 13; i > -1; i --)
    {
        if(n & (1 << i)) vec.push_back(1);
        else vec.push_back(0);
    }
}
void findOdd()
{
    for(int i = 0; i < N; i ++)
    {
        if((M[i].size()) & 1) odd.push_back(i);
    }
}
void remake()
{
    for(int i = 0; i < odd.size(); i += 2)
    {
        int v = odd[i], u = odd[i + 1];
        M[v].insert(u);
        M[u].insert(v);
        if(v > u) swap(v, u);
        //cout<<"Add: "<<v<<" "<<u<<endl;
        additional.insert(v * 100000 + u);
    }
}
void print(stack<int> st)
{
    stack<int> st2 = st;
    cout<<"st: ";
    while(st2.size())
    {
        cout<<st2.top()<<" ";
        st2.pop();
    }
    cout<<endl;
}
stack<int> euler()
{
    /*for(int i = 0; i < N; i ++)
    {
        cout<<"For i = "<<i<<endl;
        for(auto item : M[i])
        {
            cout<<item<<" ";
        }
        cout<<endl;
    }*/
    stack<int> st;
    stack<int> st2;
    st.push(0);
    while(st.size())
    {
        int tp = st.top();
        //print(st);
        if(M[tp].size())
        {
            int to = *M[tp].begin();
            //cout<<"to = "<<to<<endl;
            st.push(to);
            auto it = M[to].find(tp);
            M[to].erase(it);
            M[tp].erase(M[tp].begin());
        }
        else
        {
            st2.push(tp);
            st.pop();
        }
    }
    return st2;
}
vector<bool> encode(int n, vector<pair<int, int> > edges)
{
    vec.clear();
    additional.clear();
    odd.clear();
    for(int i = 0; i < n; i ++)
    {
        M[i].clear();
    }
    N = n;
    memset(ps, 0, n + 1);
    createAdj(edges);
    findOdd();
    remake();
    stack<int> tour = euler();
    int prev = -1, itt = 0;
    while(tour.size())
    {
        //cout<<"s: "<<tour.top()<<endl;
        addBits(tour.top());
        if(prev != -1)
        {
            int v = prev, u = tour.top();
            if(v > u) swap(v, u);
            auto it = additional.find(v * 100000 + u);
            if(it != additional.end())
            {
                ps[itt] = 1;
                additional.erase(it);
            }
        }
        prev = tour.top();
        tour.pop();
        itt ++;
    }
    addBits((1 << 14) - 1);
    for(int i = 0; i < 16000; i ++)
    {
        if(ps[i]) vec.push_back(1);
        else vec.push_back(0);
    }
    return vec;
}
int cut(vector<bool>& data)
{
    int num = 0;
    if(s + 13 >= data.size()) return ((1 << 14) - 1);
    for(int i = 13; i > -1; i --)
    {
        num += data[s + 13 - i] * (1 << i);
    }
    s += 14;
    return num;
}
vector<pair<int, int> > decode(int n, vector<bool> data)
{
    ans.clear();
    s = 0;
    vector<pair<int, int> > edges;
    int ind = 0, cur, prev = -1, tek = -1;
    while((cur = cut(data)) != ((1 << 14) - 1))
    {
        tek ++;
        if(prev != -1)
        {
            int v = cur, u = prev;
            if(v > u) swap(v, u);
            //cout<<v<<"     "<<u<<endl;
            if(ps[tek] == 0)
            {
                ans.insert(v * 100000 + u);
            }
            //else cout<<tek<<endl;
        }
        prev = cur;
    }
    for(auto it = ans.begin(); it != ans.end(); it ++)
    {
        int from = (*it) % 100000, to = (*it) / 100000;
        edges.push_back({from, to});
        //cout<<from<<" "<<to<<endl;
    }
    return edges;
}
/*
4
4 4
0 1
1 2
2 0
0 3
11 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10
4 3
0 1
1 2
2 3
4 3
0 1
0 2
0 3



1
4 4
0 1
1 2
2 3
3 0
*/
