#include<bits/stdc++.h>
#include "cactus.h"

#define MAXN 16006

using namespace std;

vector<int> path, cycle[MAXN];
unordered_multiset<int> M[MAXN];
bool vis[MAXN], isPresent[MAXN];
int N, c, s;
vector<int> odd;
vector<pair<int, int> > additional;
vector<bool> vec;
unordered_set<long long> ans;
unordered_set<long long> miss;

void createAdj(vector<pair<int, int> >& edges)
{
    for(auto edge : edges)
    {
        M[edge.first].insert(edge.second);
        M[edge.second].insert(edge.first);
    }
}
void addBits(int n)
{
    for(int i = 13; i > -1; i --)
    {
        if(n & (1 << i)) vec.push_back(1);
        else vec.push_back(0);
    }
}
void findOdd()
{
    for(int i = 0; i < N; i ++)
    {
        if((M[i].size()) & 1) odd.push_back(i);
    }
}
void remake()
{
    for(int i = 0; i < odd.size(); i += 2)
    {
        int v = odd[i], u = odd[i + 1];
        M[v].insert(u);
        M[u].insert(v);
        //cout<<"Add: "<<v<<" "<<u<<endl;
        additional.push_back({v, u});
    }
}
stack<int> euler()
{
    stack<int> st;
    stack<int> st2;
    st.push(0);
    while(st.size())
    {
        int tp = st.top();
        if(M[tp].size())
        {
            int to = *M[tp].begin();
            //cout<<"to = "<<to<<endl;
            st.push(to);
            M[to].erase(tp);
            M[tp].erase(M[tp].begin());
        }
        else
        {
            st2.push(tp);
            st.pop();
        }
    }
    return st2;
}
vector<bool> encode(int n, vector<pair<int, int> > edges)
{
    vec.clear();
    additional.clear();
    for(int i = 0; i < n; i ++)
    {
        M[i].clear();
        cycle[i].clear();
    }
    N = n;
    createAdj(edges);
    findOdd();
    remake();
    stack<int> tour = euler();
    for(auto edge : additional)
    {
        addBits(edge.first);
        addBits(edge.second);
    }
    addBits((1 << 14) - 1);
    while(tour.size())
    {
        //cout<<"s: "<<tour.top()<<endl;
        addBits(tour.top());
        tour.pop();
    }
    return vec;
}
int cut(vector<bool>& data)
{
    int num = 0;
    if(s + 13 >= data.size()) return ((1 << 14) - 1);
    for(int i = 13; i > -1; i --)
    {
        num += data[s + 13 - i] * (1 << i);
    }
    s += 14;
    return num;
}
vector<pair<int, int> > decode(int n, vector<bool> data)
{
    miss.clear();
    ans.clear();
    s = 0;
    vector<pair<int, int> > edges;
    int ind = 0, cur, prev = -1;
    while((cur = cut(data)) != ((1 << 14) - 1))
    {
        int v = cur, u = cut(data);
        if(v > u) swap(v, u);
        miss.insert(v * 100000 + u);
    }
    while((cur = cut(data)) != ((1 << 14) - 1))
    {
        if(prev != -1)
        {
            int v = cur, u = prev;
            if(v > u) swap(v, u);
            auto it = miss.find(v * 100000 + u);
            //cout<<v<<"     "<<u<<endl;
            if(it != miss.end())
            {
                miss.erase(it);
            }
            else
            {
                ans.insert(v * 100000 + u);
            }
        }
        prev = cur;
    }
    for(auto it = ans.begin(); it != ans.end(); it ++)
    {
        int from = (*it) % 100000, to = (*it) / 100000;
        edges.push_back({from, to});
        //cout<<from<<" "<<to<<endl;
    }
    return edges;
}
/*
2
4 4
0 1
1 2
2 0
0 3
11 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10

1
4 4
0 1
1 2
2 3
3 0
*/
