#include<bits/stdc++.h>
#include "cactus.h"

#define MAXN 16006
#define short int16_t

using namespace std;

vector<short> M[MAXN], cycle[MAXN];
bool vis[MAXN], isPresent[MAXN];
short N, c, pos;
vector<pair<int, int> > other;

void createCycle(vector<short>& path, int v)
{
    vector<short> cc;
    for(short i = path.size() - 1; i > -1; i --)
    {
        cycle[c].emplace_back(path[i]);
        cc.emplace_back(path[i]);
        if(path[i] == v) break;
    }
    for(short i = 0; i < cc.size(); i ++)
    {
        short nx = (i + 1) % cc.size();
        other.push_back({cc[i], cc[nx]});
        //cout<<cc[i]<<"      "<<cc[nx]<<endl;
    }
    c ++;
}
void printPath(vector<short>& path)
{
    cout<<"Path: ";
    for(auto item : path)
    {
        cout<<item<<" ";
    }
    cout<<endl;
}
void dfs(short v, short p, vector<short> path)
{
    vis[v] = 1;
    bool fl = true;
    for(auto to : M[v])
    {
        if(to == p) continue;
        if(!vis[to])
        {
            isPresent[to] = 1;
            path.push_back(to);
            dfs(to, v, path);
            path.pop_back();
            isPresent[to] = 0;
        }
        else if(isPresent[to])
        {
            fl = false;
            createCycle(path, to);
        }
    }
}
void findCycles()
{
    vector<short> ppp;
    ppp.push_back(1);
    isPresent[1] = 1;
    dfs(1, -1, ppp);
}
void createAdj(vector<pair<int, int> >& edges)
{
    for(auto edge : edges)
    {
        M[edge.first].emplace_back(edge.second);
        M[edge.second].emplace_back(edge.first);
    }
}
void addBits(short n, vector<bool>& vec)
{
    for(short i = 13; i > -1; i --)
    {
        if(n & (1 << i)) vec.push_back(1);
        else vec.push_back(0);
    }
}
vector<bool> encode(int n, vector<pair<int, int> > edges)
{
    other.clear();
    for(short i = 0; i < n; i ++)
    {
        cycle[i].clear();
        M[i].clear();
    }
    memset(vis, 0, n + 1);
    memset(isPresent, 0, n + 1);
    N = c = pos = 0;
    N = n;
    createAdj(edges);
    findCycles();
    vector<bool> vec;
    for(short i = 0; i < c; i ++)
    {
        addBits(cycle[i].size(), vec);
        for(auto v : cycle[i]) addBits(v, vec);
    }
    addBits((1 << 14) - 1, vec);
    for (auto& [u, v] : edges)
    {
        if (u > v) swap(u, v);
    }
    sort(edges.begin(), edges.end());
    for (auto& [u, v] : other)
    {
        if (u > v) swap(u, v);
    }
    sort(other.begin(), other.end());
    short ind = 0;
    for(auto edge : edges)
    {
        while(edge != other[ind])
        {
            addBits(edge.first, vec);
            addBits(edge.second, vec);
            //cout<<edge.first<<" "<<edge.second<<endl;
            break;
        }
        if(edge == other[ind]) ind ++;
    }
    return vec;
}
short cut(short s, vector<bool>& data)
{
    short num = 0;
    for(short i = 13; i > -1; i --)
    {
        num += data[s + 13 - i] * (1 << i);
    }
    return num;
}
vector<pair<int, int> > decode(int n, vector<bool> data)
{
    vector<pair<int, int> > edges;
    N = n;
    short ed = (1 << 14) - 1;
    short ind = 0;
    while(cut(ind, data) != ed)
    {
        short sz = cut(ind, data);
        //cout<<"sz = "<<sz<<endl;
        ind += 14;
        short f = cut(ind, data);
        short prev = f;
        ind += 14;
        for(short i = 1; i < sz; i ++)
        {
            short cur = cut(ind, data);
            edges.push_back({cur, prev});
            prev = cur;
            ind += 14;
        }
        edges.push_back({f, prev});
    }
    ind += 14;
    while(ind < data.size())
    {
        short from = cut(ind, data);
        short to = cut(ind + 14, data);
        edges.push_back({from, to});
        ind += 28;
    }
    return edges;
}
/*
2
3 4
0 1
1 2
2 0
0 3
11 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10
*/
