#include<bits/stdc++.h>
#include "cactus.h"

#define MAXN 16006

using namespace std;

vector<int> M[MAXN], path, cycle[MAXN];
bool vis[MAXN], isPresent[MAXN];
map<pair<int, int>, bool> adj;
int N, c, pos;

void createCycle(vector<int>& path, int v)
{
    vector<int> cc;
    for(int i = path.size() - 1; i > -1; i --)
    {
        cycle[c].emplace_back(path[i]);
        cc.emplace_back(path[i]);
        if(path[i] == v) break;
    }
    for(int i = 0; i < cc.size(); i ++)
    {
        int nx = (i + 1) % cc.size();
        //cout<<cc[i]<<"      "<<cc[nx]<<endl;
        adj[{cc[i],cc[nx]}] = adj[{cc[nx],cc[i]}] = 0;
    }
    c ++;
}
void printPath(vector<int>& path)
{
    cout<<"Path: ";
    for(auto item : path)
    {
        cout<<item<<" ";
    }
    cout<<endl;
}
void dfs(int v, int p, vector<int> path)
{
    vis[v] = 1;
    for(auto to : M[v])
    {
        if(to == p) continue;
        if(!vis[to])
        {
            isPresent[to] = 1;
            path.push_back(to);
            dfs(to, v, path);
            path.pop_back();
            isPresent[to] = 0;
        }
        else if(isPresent[to])
        {
            createCycle(path, to);
        }
    }
}
void findCycles()
{
    vector<int> ppp;
    ppp.push_back(1);
    isPresent[1] = 1;
    dfs(1, -1, ppp);
}
void createAdj(vector<pair<int, int> >& edges)
{
    for(auto edge : edges)
    {
        M[edge.first].emplace_back(edge.second);
        M[edge.second].emplace_back(edge.first);
        adj[{edge.first,edge.second}] = adj[{edge.second,edge.first}] = 1;
    }
}
void addBits(int n, vector<bool>& vec)
{
    for(int i = 13; i > -1; i --)
    {
        if(n & (1 << i)) vec.push_back(1);
        else vec.push_back(0);
    }
}
vector<bool> encode(int n, vector<pair<int, int> > edges)
{
    path.clear();
    adj.clear();
    for(int i = 0; i < n; i ++)
    {
        cycle[i].clear();
        M[i].clear();
    }
    memset(vis, 0, n + 1);
    memset(isPresent, 0, n + 1);
    N = c = pos = 0;
    N = n;
    createAdj(edges);
    findCycles();
    vector<bool> vec;
    for(int i = 0; i < c; i ++)
    {
        addBits(cycle[i].size(), vec);
        for(auto v : cycle[i]) addBits(v, vec);
    }
    addBits((1 << 14) - 1, vec);
    for(auto edge : edges)
    {
        if(adj[{edge.first,edge.second}])
        {
            addBits(edge.first, vec);
            addBits(edge.second, vec);
        }
    }
    /*for(int i = 0; i < vec.size(); i += 14)
    {
        for(int j = 0; j < 14; j ++)
        {
            cout<<vec[i + j];
        }
        cout<<endl;
    }*/
    return vec;
}
int cut(int s, vector<bool>& data)
{
    int num = 0;
    for(int i = 13; i > -1; i --)
    {
        num += data[s + 13 - i] * (1 << i);
    }
    return num;
}
vector<pair<int, int> > decode(int n, vector<bool> data)
{
    vector<pair<int, int> > edges;
    N = n;
    int ed = (1 << 14) - 1;
    int ind = 0;
    while(cut(ind, data) != ed)
    {
        int sz = cut(ind, data);
        //cout<<"sz = "<<sz<<endl;
        ind += 14;
        int f = cut(ind, data);
        int prev = f;
        ind += 14;
        for(int i = 1; i < sz; i ++)
        {
            int cur = cut(ind, data);
            edges.push_back({cur, prev});
            prev = cur;
            ind += 14;
        }
        edges.push_back({f, prev});
    }
    ind += 14;
    while(ind < data.size())
    {
        int from = cut(ind, data);
        int to = cut(ind + 14, data);
        edges.push_back({from, to});
        ind += 28;
    }
    return edges;
}
/*
2
3 4
0 1
1 2
2 0
0 3
11 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10
*/
