#include<bits/stdc++.h>
#include "cactus.h"
using namespace std;

vector<bool> toBool(int a, int bitSize) {
    //printf("encode %d\n",a);
    vector<bool> res(bitSize);
    auto it = res.end();
    while(a != 0) {
        *(--it) = a & 1;
        a >>= 1;
    }
    return res;
}

int toInt(vector<bool>::iterator first, vector<bool>::iterator last) {
    //printf("decode num\n");
    int res = 0;
    while(first != last) {
        res <<= 1;
        res += *(first++);
    }
    //printf("decoded %d\n", res);
    return res;
}

bool visited[16000];

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges) {
    //printf("start encode func\n");
    vector<bool> res;
    vector<pair<int, int>> paths[16000];
    int bitSize = 1 + floor(log2(n));
    for(int i = 0; i < edges.size(); i++) {
        paths[edges[i].first].push_back({edges[i].second, i});
        paths[edges[i].second].push_back({edges[i].first, i});
    }

    vector<vector<int>> loops;
    stack<pair<int, int>> s;
    list<int> seq;
    s.push({-1, 0});
    visited[0] = true;
    while(!s.empty()) {
        while(!seq.empty() && seq.back() != s.top().first) seq.pop_back();
        int curr = s.top().second;
        int prev = s.top().first;
        //printf("look at %d -> %d\n",prev,curr);
        s.pop();
        seq.push_back(curr);
        for(pair<int, int> dest: paths[curr]) {
            if(!visited[dest.first]) {
                // new node
                s.push({curr,dest.first});
                visited[dest.first] = true;
                //printf("add %d -> %d\n",curr,dest.first);
            }
            else if(prev != dest.first) {
                // loop marked
                if(!loops.empty()){
                    bool flag = false;
                    for(vector<int> loop: loops) {
                        if(loop.front() == curr) {
                            flag = true;
                            break;
                        }
                    }
                    if(flag) continue;
                }

                // mark loop
                loops.push_back(vector<int>({dest.first}));
                auto it = seq.end();
                //printf("%d",dest.first);
                do {
                    loops.back().push_back(*--it);
                    //printf("%d",*it);
                } while(*it != s.top().first);
                //printf(" loop\n",loops.back().front());
            }
        }
    }
    // find unused
    //printf("unused\n");
    for(int i = 0; i < loops.size(); i++) {
        loops[i].push_back(loops[i][0]);
        for(int j = 0; j < loops[i].size() - 1; j++) {
            for(int k = 0; k < paths[loops[i][j]].size(); k++) {
                if(paths[loops[i][j]][k].first == loops[i][j+1]) {
                    edges[paths[loops[i][j]][k].second] = {-1, -1};
                    break;
                }
            }
        }
    }
    // insert loops
    vector<bool> ins;
    for(vector<int> loop: loops) {
        for(int node: loop) {
            ins = toBool(node, bitSize);
            res.insert(res.end(),ins.begin(),ins.end());
        }
    }
    ins = toBool(n, bitSize); // signify end
    // insert non loop
    res.insert(res.end(),ins.begin(),ins.end());
    for(pair<int,int> edge: edges) {
        if(edge.first == -1) continue;
        ins = toBool(edge.first, bitSize);
        res.insert(res.end(),ins.begin(),ins.end());
        ins = toBool(edge.second, bitSize);
        res.insert(res.end(),ins.begin(),ins.end());
    }

    return res;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data) {
    //printf("start decode func\n");
    vector<pair<int, int>> res;
    int bitSize = 1 + floor(log2(n));
    auto it = data.begin();
    list<int> loopNodes;
    do {
        int a = toInt(it, it + bitSize);
        it += bitSize;
        if(a == n) break;
        if(loopNodes.empty()) {
            loopNodes.push_back(a);
            continue;
        }
        res.push_back({a,loopNodes.back()});
        loopNodes.push_back(a);
        if(!loopNodes.empty() && a == loopNodes.front()) {
            // end loop
            loopNodes.clear();
        }
    } while(true);
    while(it != data.end()) {
        int a = toInt(it, it + bitSize);
        it += bitSize;
        int b = toInt(it, it + bitSize);
        it += bitSize;
        res.push_back({a,b});
    }
    return res;
}
