#include<bits/stdc++.h>
#include "cactus.h"
using namespace std;

vector<bool> toBool(int a, int bitSize) {
    //printf("encode %d\n",a);
    vector<bool> res(bitSize);
    auto it = res.end();
    while(a != 0) {
        *(--it) = a & 1;
        a >>= 1;
    }
    return res;
}

int toInt(vector<bool>::iterator first, vector<bool>::iterator last) {
    //printf("decode num\n");
    int res = 0;
    while(first != last) {
        res <<= 1;
        res += *(first++);
    }
    //printf("decoded %d\n", res);
    return res;
}

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges) {
    //printf("start encode func\n");
    vector<bool> res;
    int bitSize = 1 + floor(log2(n));
    for(pair<int, int> edge: edges) {
        vector<bool> ins = toBool(edge.first, bitSize);
        res.insert(res.end(), ins.begin(), ins.end());
        ins = toBool(edge.second, bitSize);
        res.insert(res.end(), ins.begin(), ins.end());
    }
    return res;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data) {
    //printf("start decode func\n");
    vector<pair<int, int>> res;
    int bitSize = 1 + floor(log2(n));
    auto it = data.begin();
    while(it != data.end()) {
        int a = toInt(it, it + bitSize);
        it += bitSize;
        int b = toInt(it, it + bitSize);
        it += bitSize;
        res.push_back({a,b});
    }
    return res;
}
