#include <bits/stdc++.h>
#include "cactus.h"

#ifdef __LOCAL__
    #include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

const int MAXN = 2e4;
const int SPACE_BIT_SIZE = 15;

void FillSpaceElement(int &pos, vector <bool> &v)
{
    int br = 0;
    for (int i = pos; br < SPACE_BIT_SIZE; i++, br++)
    {
        v.push_back(0);
    }

    pos += SPACE_BIT_SIZE;
}

/*void FillNextNodeElement(int pos, vector <bool> &v)
{
    int br = 0;
    for (int i = pos; br < SPACE_BIT_SIZE; i++, br++)
    {
        v.push_back(0);
    }
}*/

void FillNumberBits(int a, int& pos, vector <bool> &v)
{
    stack <int> num;

    while (a)
    {
        num.push(a&1);
        a >>= 1;
    }

    while (!num.empty())
    {
        v.push_back(num.top());
        pos++;
        num.pop();
    }
}

void CheckSpaceBits(const vector <bool> &data, vector <int> &table, const int startPos)
{
    if (table[startPos] != 0)
        return;

    int pos = startPos;

    int br = 0;
    while (pos < data.size() && data[pos] == 0)
    {
        pos++;
        br++;
    }

    if (br < SPACE_BIT_SIZE)
        return;

    pos = br%SPACE_BIT_SIZE + startPos;

    for (br = 0; pos < data.size() && br < SPACE_BIT_SIZE; pos++, br++)
    {
        table[pos] = 1;
    }
}

/*void CheckNodeBits(const vector <bool> &data, vector <int> &table, const int startPos)
{
    if (table[startPos] != 0)
        return;

    int pos = startPos;

    int br = 0;
    while (pos < data.size() && data[pos] == 0)
    {
        pos++;
        br++;
    }

    if (br < SPACE_BIT_SIZE)
        return;

    pos = br-SPACE_BIT_SIZE + startPos;

    for (br = 0; pos < data.size() && br < SPACE_BIT_SIZE; pos++, br++)
    {
        table[pos] = 1;
    }
}*/

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    vector <bool> encoded;

    for (auto &[u, v]: edges)
    {
        if (u > v)
            swap(u, v);
    }
    sort(edges.begin(), edges.end());

    int currNode = 0;
    int pos = 0;
    for (int i = 0; i < edges.size(); i++)
    {
        int u = edges[i].first;
        int v = edges[i].second;

        FillNumberBits(u+1, pos, encoded);
        FillSpaceElement(pos, encoded);
        FillNumberBits(v+1, pos, encoded);

        if (i == edges.size()-1)
            break;

        FillSpaceElement(pos, encoded);
    }

    /*for (auto bit:encoded)
        cout << bit;
    cout << endl;*/

    return encoded;

}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    int i;
    vector <pair <int, int>> edges;

    vector <int> type(data.size());

    for (int i = 0; i < data.size(); i++)
        type[i] = 0;

    for (int i = 0; i < data.size(); i++)
        CheckSpaceBits(data, type, i);

    /*cout << endl;
    for (int i = 0; i < data.size(); i++)
        cout << type[i];
    cout << endl;*/

    i = 0;
    int num = 0;
    int u = -1, v = -1;

    vector <int> nodes;
    while (i < data.size())
    {
        if (type[i] == 0)
        {
            num = num*2 + data[i];
            i++;
            continue;
        }

        else if (type[i] == 1)
        {
            nodes.push_back(num-1);
            num = 0;
            i += SPACE_BIT_SIZE;
        }

    }

    nodes.push_back(num-1);

    for (int i = 0; i < nodes.size(); i += 2)
    {
        //cout << nodes[i] << " " << nodes[i+1] << endl;
        edges.emplace_back(nodes[i], nodes[i+1]);
    }
    return edges;
}
