#include <bits/stdc++.h>
#include "cactus.h"

#ifdef __LOCAL__
    #include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

const int MAXN = 2e4;
const int SPACE_BIT_SIZE = 16;

void FillSpaceElement(int pos, vector <bool> &v)
{
    int br = 0;
    for (int i = pos; br < SPACE_BIT_SIZE; i++, br++)
    {
        v.push_back(0);
    }
}

/*void FillNextNodeElement(int pos, vector <bool> &v)
{
    int br = 0;
    for (int i = pos; br < SPACE_BIT_SIZE; i++, br++)
    {
        v.push_back(0);
    }
}*/

void FillNumberBits(int a, int& pos, vector <bool> &v)
{
    stack <int> num;

    while (a)
    {
        num.push(a&1);
        a >>= 1;
    }

    while (!num.empty())
    {
        v.push_back(num.top());
        pos++;
        num.pop();
    }
}

void CheckSpaceBits(const vector <bool> &data, vector <int> &table, const int startPos)
{
    if (table[startPos] != 0)
        return;

    int pos = startPos;

    int br = 0;
    while (pos < data.size() && data[pos] == 0)
    {
        pos++;
        br++;
    }

    if (br < SPACE_BIT_SIZE)
        return;

    pos = br%SPACE_BIT_SIZE + startPos;

    for (br = 0; pos < data.size() && br < SPACE_BIT_SIZE; pos++, br++)
    {
        table[pos] = 1;
    }
}

/*void CheckNodeBits(const vector <bool> &data, vector <int> &table, const int startPos)
{
    if (table[startPos] != 0)
        return;

    int pos = startPos;

    int br = 0;
    while (pos < data.size() && data[pos] == 0)
    {
        pos++;
        br++;
    }

    if (br < SPACE_BIT_SIZE)
        return;

    pos = br-SPACE_BIT_SIZE + startPos;

    for (br = 0; pos < data.size() && br < SPACE_BIT_SIZE; pos++, br++)
    {
        table[pos] = 1;
    }
}*/

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    vector <bool> encoded;

    for (auto &[u, v]: edges)
    {
        if (u > v)
            swap(u, v);
    }
    sort(edges.begin(), edges.end());

    int currNode = 0;
    int pos = 0;
    for (int i = 0; i < edges.size(); i++)
    {
        int u = edges[i].first;
        int v = edges[i].second;

        while (currNode < u)
        {
            //cout << currNode << endl;
            FillNumberBits(currNode+1, pos, encoded);

            currNode++;

            FillSpaceElement(pos, encoded);
            pos += SPACE_BIT_SIZE;
        }

        //cout << "!! " << v+1 << endl;
        FillNumberBits(v+1, pos, encoded);
        FillSpaceElement(pos, encoded);

        pos += SPACE_BIT_SIZE;

    }

    /*for (auto bit:encoded)
        cout << bit;
    cout << endl;*/

    return encoded;

}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    int i;
    vector <pair <int, int>> edges;

    vector <int> type(data.size());

    for (int i = 0; i < data.size(); i++)
        type[i] = 0;

    for (int i = 0; i < data.size(); i++)
    {
        CheckSpaceBits(data, type, i);
    }

    /*cout << endl;
    for (int i = 0; i < data.size(); i++)
        cout << type[i];
    cout << endl;*/

    int currNode = 1, num = 0;

    while (i < data.size())
    {
        if (type[i] == 0)
        {
            num = num*2 + data[i];
            i++;
            continue;
        }

        else if (type[i] == 1)
        {

            if (currNode == num)
            {
                currNode++;
                num = 0;
                i += SPACE_BIT_SIZE;
                continue;
            }

            edges.push_back({currNode-1, num-1});

            num = 0;
            i += SPACE_BIT_SIZE;


        }


    }
    return edges;
}
