#include <bits/stdc++.h>
#include "cactus.h"
using namespace std;

const int maxn = 16002, maxb = 16, pausa = 16300, pausa2 = 16301;
struct vertex
{
    int idx;
    int st = 0;
};
vertex a[maxn];
bool usedver[maxn];
int pos[maxn], sz[maxn], pw[maxb];
vector <int> v[maxn];
unordered_map <long long, bool> used;

bool cmp(vertex v1, vertex v2)
{
    return (v1.st > v2.st);
}

string to_2(int num)
{
    //cout << num << " - " ;
    string s = "00000000000000";
    int pos = 13;
    do
    {
        if (num&1)
            s[pos] = '1';
        -- pos;
        num >>= 1;
    }while (num);
    //cout << s << '\n' ;
    return s;
}

void add_to_ans(vector<bool>&ans, string s)
{
    int i, len = 14;
    for (i=0; i<len; ++i)
    {
        if (s[i] == '0')
            ans.push_back(false);
        else
            ans.push_back(true);
    }
}

void init(int n)
{
    int i;
    vector <int> h;
    for (i=0; i<n; ++i)
    {
        a[i].st = 0;
        v[i] = h;
        usedver[i] = false;
    }
    used.clear();
}

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    init(n);
    int m = (int)(edges.size()), i, x, y;
    for (i=0; i<m; ++i)
    {
        x = edges[i].first;
        y = edges[i].second;
        v[x].push_back(y);
        v[y].push_back(x);
        a[x].st++; a[y].st++;
        a[x].idx = x; a[y].idx = y;
        //cout << x << "*" << y << '\n' ;
    }
    //cout << '\n' ;

    for (i=0; i<n; ++i)
        sz[i] = a[i].st;
    sort(a, a+n, cmp);
    for (i=0; i<n; ++i)
        pos[a[i].idx] = i;

    vector <bool> ans;
    vector <pair<int,int>> pairs;
    int j, len;
    long long edge;
    bool lamp = false;
    for (i=0; i<n/2; ++i)
    {
        x = a[i].idx;
        usedver[x] = true;
        len = a[i].st;
        if (len <= 0)
            continue;
        if (len == 1)
        {
            for (j=0; j<sz[x]; ++j)
            {
                y = v[x][j];
                edge = (long long)(x)*(long long)(maxn)+(long long)(y);
                if (used[edge] == 0)
                {
                    pairs.push_back({x,y});
                    a[pos[y]].st --;
                    a[pos[x]].st --;
                    used[edge] = true;
                    edge = (long long)(y)*(long long)(maxn)+(long long)(x);
                    used[edge] = true;
                }
            }
            continue;
        }

        if (!lamp) lamp = true;
        else add_to_ans(ans, to_2(pausa));
        add_to_ans(ans, to_2(x));

        for (j=0; j<sz[x]; ++j)
        {
            y = v[x][j];
            edge = (long long)(x)*(long long)(maxn)+(long long)(y);
            if (used[edge] == 0)
            {
                add_to_ans(ans, to_2(y));
                a[pos[y]].st --;
                a[pos[x]].st --;
                used[edge] = true;
                edge = (long long)(y)*(long long)(maxn)+(long long)(x);
                used[edge] = true;
            }
        }
    }

    sort(a, a+n, cmp);
    for (i=0; i<n; ++i)
        pos[a[i].idx] = i;

    for (i=0; i<n; ++i)
    {
        x = a[i].idx;
        if (usedver[x])
            continue;
        usedver[x] = true;

        len = a[i].st;
        if (len <= 0)
            continue;
        if (len == 1)
        {
            for (j=0; j<sz[x]; ++j)
            {
                y = v[x][j];
                edge = (long long)(x)*(long long)(maxn)+(long long)(y);
                if (used[edge] == 0)
                {
                    pairs.push_back({x,y});
                    a[pos[y]].st --;
                    a[pos[x]].st --;
                    used[edge] = true;
                    edge = (long long)(y)*(long long)(maxn)+(long long)(x);
                    used[edge] = true;
                }
            }
            continue;
        }

        if (!lamp) lamp = true;
        else add_to_ans(ans, to_2(pausa));
        add_to_ans(ans, to_2(x));

        for (j=0; j<sz[x]; ++j)
        {
            y = v[x][j];
            edge = (long long)(x)*(long long)(maxn)+(long long)(y);
            if (used[edge] == 0)
            {
                add_to_ans(ans, to_2(y));
                a[pos[y]].st --;
                a[pos[x]].st --;
                used[edge] = true;
                edge = (long long)(y)*(long long)(maxn)+(long long)(x);
                used[edge] = true;
            }
        }
    }

    len = (int)(pairs.size());
    if (len)
    {
        add_to_ans(ans, to_2(pausa2));
        for (i=0; i<len; ++i)
        {
            x = pairs[i].first;
            y = pairs[i].second;
            add_to_ans(ans, to_2(x));
            add_to_ans(ans, to_2(y));
        }
    }

    //cout << "out" << endl;
    return ans;
}

void pow2()
{
    int i;
    pw[0] = 1;
    for (i=1; i<maxb; ++i)
        pw[i] = pw[i-1] * 2;
}

int to_10(string s)
{
    int i, len = 14, res = 0;
    for (i=0; i<len; ++i)
    {
        if (s[i] == '1')
            res += (pw[13-i]);
    }
    return res;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    //cout << "in" << endl;
    vector <pair<int, int>> ans;
    pow2();
    int i, len = (int)(data.size()), j, x = -1, y = -1, num;
    bool lamp = false;
    string s;
    for (i=0; i<len; i+=14)
    {
        s = "00000000000000";
        for (j=i; j<i+14; ++j)
        {
            if (data[j])
                s[j%14] = '1';
        }

        num = to_10(s);
        if (num == pausa2)
        {
            lamp = true;
            continue;
        }
        if (lamp)
        {
            if (x != -1 && y != -1)
                x = -1, y = -1;
            if (x == -1)
                x = num;
            else
            {
                y = num;
                ans.push_back({x, y});
            }
            continue;
        }

        if (num == pausa)
            x = -1, y = -1;
        else if (x == -1)
            x = num;
        else
        {
            y = num;
            ans.push_back({x, y});
            //cout << x << " -> " << y << endl ;
        }
    }
    return ans;
}

/*

2
11 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10
11 12
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9

*/