# include <iostream>
# include <vector>
# include <algorithm>
# include <map>
# include <cstring>
using namespace std;
# include "cactus.h"
//# include "Lgrader.cpp"

const int MAX=1e6+11;

vector<pair<int,int>> adj_euler[MAX];
vector<int> v;
int deg[MAX];

int ptr[MAX];
int edge_vis[MAX];

void euler(int curr)
{
    for(int& id=ptr[curr];id<(int)adj_euler[curr].size();id++)
    {
        int nxt=adj_euler[curr][id].first,edge_id=adj_euler[curr][id].second;
        if(edge_vis[edge_id]) continue;

        edge_vis[edge_id]=1;
        euler(nxt);
    }

    v.push_back(curr);
}

bool toAdd[MAX];

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    memset(toAdd,0,sizeof(toAdd));
    memset(edge_vis,0,sizeof(edge_vis));
    v.clear();
    for(int i=0;i<n;i++)
    {
        adj_euler[i].clear();
        ptr[i]=0;
        deg[i]=0;
    }

    int ct=0;
    map<pair<int,int>,bool> in;
    for(pair<int,int> pa: edges)
    {
        int u=pa.first,v=pa.second;
        in[{u,v}]=1;
        in[{v,u}]=1;
        deg[u]^=1;
        deg[v]^=1;

        ct++;
        adj_euler[u].push_back({v,ct});
        adj_euler[v].push_back({u,ct});
    }


    vector<int> odd;
    for(int i=0;i<n;i++) if(deg[i]) odd.push_back(i);

    for(int i=0;i<(int)odd.size();i+=2)
    {
        int u=odd[i],v=odd[i+1];
        ct++;
        adj_euler[u].push_back({v,ct});
        adj_euler[v].push_back({u,ct});
    }

    euler(n-1);

    for(int i=0;i<(int)v.size()-1;i++)
    {
        if(!(in.find({v[i],v[i+1]})!=in.end() or in.find({v[i+1],v[i]})!=in.end())) toAdd[i+1]=1;
    }

    for(int i=0;i<(int)v.size();i++)
    {
        if(toAdd[i]) v[i]+=n;
    }

    //for(int x: v) cout<<x<<" ";
    //cout<<"\n";

    vector<bool> fnl;
    for(int x: v)
    {
        int K=15;
        for(int i=0;i<K;i++)
        {
            fnl.push_back(x%2);
            x/=2;
        }
    }

    return fnl;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    int K=15;
    vector<int> num;
    for(int i=0;i<(int)data.size();i+=K)
    {
        int x=0;
        for(int j=i+K-1;j>=i;j--)
        {
            x*=2;
            if(data[j]) x++;
        }

        num.push_back(x);
    }

    //cout<<"decode:"<<"\n";
    //for(int x: num) cout<<x<<" ";
    //cout<<"\n";

    vector<pair<int,int>> fnl;
    map<pair<int,int>,bool> used;
    for(int i=0;i<(int)num.size()-1;i++)
    {
        if(num[i+1]<n)
        {
            if(num[i]>n) num[i]-=n;

            int u=num[i],v=num[i+1];
            if(u>v) swap(u,v);

            if(used.find({u,v})==used.end())
            {
                used[{u,v}]=1;
                fnl.push_back({num[i],num[i+1]});
            }

            //cout<<num[i]<<" "<<num[i+1]<<"\n";
        }
    }


    return fnl;
}


/*
2
11 13
0 1
1 2
2 0
1 3
3 4
4 5
5 1
2 6
6 7
7 8
8 6
2 9
9 10
2 1
0 1
*/
