# include <iostream>
# include <vector>
# include <algorithm>
# include <map>
using namespace std;
# include "cactus.h"
//# include "Lgrader.cpp"

const int MAX=16011;
const int K=15;

vector<int> adj[MAX];
vector<pair<int,int>> adj_euler[MAX];
vector<int> v;
int deg[MAX];

int ptr[MAX];
int edge_vis[MAX];

void euler(int curr)
{
    for(int& id=ptr[curr];id<(int)adj_euler[curr].size();id++)
    {
        int nxt=adj_euler[curr][id].first,edge_id=adj_euler[curr][id].second;
        if(edge_vis[edge_id]) continue;

        edge_vis[edge_id]=1;
        euler(nxt);
    }

    v.push_back(curr);
}

void push(vector<bool>& v, int x)
{
    for(int i=0;i<K;i++)
    {
        v.push_back(x%2);
        x/=2;
    }
}

bool toAdd[MAX];

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    int ct=0;
    map<pair<int,int>,bool> in;
    for(pair<int,int> pa: edges)
    {
        int u=pa.first,v=pa.second;
        //adj[u].push_back(v);
        //adj[v].push_back(u);
        in[{u,v}]=1;
        in[{v,u}]=1;
        deg[u]^=1;
        deg[v]^=1;

        ct++;
        adj_euler[u].push_back({v,ct});
        adj_euler[v].push_back({u,ct});
    }


    vector<int> odd;
    for(int i=0;i<n;i++) if(deg[i]) odd.push_back(i);

    for(int i=0;i<(int)odd.size();i+=2)
    {
        int u=odd[i],v=odd[i+1];
        ct++;
        adj_euler[u].push_back({v,ct});
        adj_euler[v].push_back({u,ct});
    }

    euler(0);

    for(int i=0;i<(int)v.size()-1;i++)
    {
        if(!(in.find({v[i],v[i+1]})!=in.end() or in.find({v[i+1],v[i]})!=in.end())) toAdd[i+1]=1;
    }

    for(int i=0;i<(int)v.size();i++)
    {
        if(toAdd[i]) v[i]+=n;
    }

    //for(int x: v) cout<<x<<" ";
    //cout<<"\n";

    vector<bool> fnl;
    for(int x: v)
    {
        push(fnl,x);
    }

    return fnl;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector<int> num;
    for(int i=0;i<(int)data.size();i+=K)
    {
        int x=0;
        for(int j=i+K-1;j>=i;j--)
        {
            x*=2;
            if(data[j]) x++;
        }

        num.push_back(x);
    }

    //cout<<"decode:"<<"\n";
    //for(int x: num) cout<<x<<" ";
    //cout<<"\n";

    vector<pair<int,int>> fnl;
    int last=-1;
    for(int x: num)
    {
        if(x>n) last=x-n;
        else
        {
            if(last!=-1)
            {
                fnl.push_back({last,x});
                //cout<<last<<"->"<<x<<"\n";
            }
            last=x;
        }
    }

    return fnl;
}



