# include <iostream>
# include <vector>
# include <algorithm>
# include <map>
using namespace std;
# include "cactus.h"
//# include "Lgrader.cpp"

int sum(int l, int r)
{
    return (r-l+1)*(l+r)/2;
}

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    const int K=25;

    vector<bool> v;
    for(pair<int,int> pa: edges)
    {
        if(pa.first<pa.second) swap(pa.first,pa.second);
        int x=sum(0,pa.first)+pa.second;
        //int x=pa.first*n+pa.second;
        for(int i=0;i<K;i++)
        {
            v.push_back(x%2);
            x/=2;
        }
    }

    return v;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    const int K=25;

    vector<pair<int,int>> edges;
    for(int i=0;i<(int)data.size();i+=K)
    {
        int x=0;
        for(int j=i+K-1;j>=i;j--)
        {
            x*=2;
            if(data[j]) x++;
        }

        int u=0,v=0;
        int l=0,r=n-1;
        while(l<=r)
        {
            int mid=(l+r)/2;
            if(sum(0,mid)<=x and x<sum(0,mid+1))
            {
                u=mid;
                v=x-sum(0,mid);
                break;
            }

            if(sum(0,mid+1)<=x) l=mid+1;
            else r=mid-1;
        }

        edges.push_back({u,v});
    }

    return edges;
}
