# define _GLIBCXX_FILESYSTEM
# include "cactus.h"
# include <bits/stdc++.h>
using namespace std;

vector<bool> encode(int N, vector<pair<int, int>> Edges)
{
    const int MAXN = N + 1;
    const int MAXEDGE = (int)Edges.size() + 1;

    struct FUN
    {
        vector<vector<pair<int, int>>> Graph;
        vector<int> Order;
        vector<int> Visited;
        int Mark;

        void Dfs(int U)
        {
            Order.push_back(U);
            int Counter = 0;

            for(auto& [V, Id] : Graph[U])
            {
                if(Visited[Id] == Mark) continue;
                Visited[Id] = Mark;
                if(Counter > 0)
                {
                    Order.push_back(-1);
                    Order.push_back(U);
                }
                Dfs(V);
                Counter++;
            }
        }
    };

    FUN RUN;
    RUN.Graph.resize(MAXN);
    RUN.Visited.resize(MAXEDGE);
    vector<int> GOAT;
    int Id = 0;
    vector<bool> Data;
    vector<int> Power(15, 0);

    Power[0] = 1;
    for(int i = 1; i < 14; i++) Power[i] = Power[i - 1] * 2;

    for(auto& [U, V] : Edges)
    {
        RUN.Graph[U].push_back({V, Id});
        RUN.Graph[V].push_back({U, Id});
        Id++;
    }

    int CYCLE = 3;
    int i;
    vector<int> LLL;

    for(int i = 0; i < N; i++) LLL.push_back(i);

    while(CYCLE--)
    {
        random_shuffle(LLL.begin(), LLL.end());
        i = LLL[0];
        RUN.Order.clear();
        RUN.Mark++;
        RUN.Dfs(i);
        if(GOAT.empty() || (int)GOAT.size() > (int)RUN.Order.size()) GOAT = RUN.Order;
    }

    for(auto& U : GOAT)
    {
        for(int Bit = 0; Bit < 14; Bit++)
        {
            if(((U + 1) & Power[Bit]))
            {
                Data.push_back(true);
            }
            else
            {
                Data.push_back(false);
            }
        }
    }

    return Data;
}

vector<pair<int, int>> decode(int N, vector<bool> Data)
{
    vector<pair<int, int>> Edges;
    vector<int> Power(15, 0);
    Power[0] = 1;
    for(int i = 1; i < 14; i++) Power[i] = Power[i - 1] * 2;
    int U = 0;

    for(int i = 13; i < (int)Data.size(); i += 14)
    {
        int V = 0;
        int Start = i - 13;

        for(int Bit = 0; Bit < 14; Bit++)
        {
            if(Data[Start]) V += Power[Bit];
            Start++;
        }

        if(U > 0 && V > 0) Edges.push_back({U - 1, V - 1});
        U = V;
    }

    return Edges;
}

