# define _GLIBCXX_FILESYSTEM
# include "cactus.h"
# include <bits/stdc++.h>
using namespace std;

const int MAXN = 16001;
vector<bool> DDD;

vector<bool> encode(int N, vector<pair<int, int>> Edges)
{
    vector<bool> DDD;
    vector<int> Power(15, 0);
    Power[0] = 1;
    for(int i = 1; i < 14; i++) Power[i] = Power[i - 1] * 2;

    for(auto& [U, V] : Edges)
    {
        for(int Bit = 0; Bit < 14; Bit++)
        {
            if((U & Power[Bit]))
            {
                DDD.push_back(true);
            }
            else
            {
                DDD.push_back(false);
            }
        }

        for(int Bit = 0; Bit < 14; Bit++)
        {
            if((V & Power[Bit]))
            {
                DDD.push_back(true);
            }
            else
            {
                DDD.push_back(false);
            }
        }
    }

    return DDD;
}

vector<pair<int, int>> decode(int N, vector<bool> Data)
{
    vector<pair<int, int>> Edges;
    vector<int> Power(15, 0);
    Power[0] = 1;
    for(int i = 1; i < 14; i++) Power[i] = Power[i - 1] * 2;

    for(int i = 27; i < (int)Data.size(); i += 28)
    {
        int U = 0, V = 0;
        int Start = i - 27;

        for(int Bit = 0; Bit < 14; Bit++)
        {
            if(Data[Start]) U += Power[Bit];
            Start++;
        }

        for(int Bit = 0; Bit < 14; Bit++)
        {
            if(Data[Start]) V += Power[Bit];
            Start++;
        }

        Edges.push_back({U, V});
    }

    return Edges;
}
