# define _GLIBCXX_FILESYSTEM
# include "cactus.h"
# include <bits/stdc++.h>
using namespace std;

struct Edge
{
    int To;
    int Id;
};

const int MAXN = 16001;
const int MAXM = 5 * MAXN + 1;
vector<Edge> Graph[MAXN];
vector<int> Order;
bool Visited[MAXM];
bool VisitedVertex[MAXN];

void Dfs(int U)
{
    Order.push_back(U + 1);
    VisitedVertex[U] = true;
    int Counter = 0;

    for(auto& [V, I] : Graph[U])
    {
        if(Visited[I]) continue;
        Visited[I] = true;
        if(Counter > 0)
        {
            Order.push_back(0);
            Order.push_back(U + 1);
        }
        Dfs(V);
        Counter++;
    }
}

vector<bool> encode(int N, vector<pair<int, int>> Edges)
{
    int I = 0;
    vector<bool> Data;
    vector<int> Power(15, 0);
    Power[0] = 1;
    for(int i = 1; i < 14; i++) Power[i] = Power[i - 1] * 2;

    for(auto& [U, V] : Edges)
    {
        Graph[U].push_back({V, I});
        Graph[V].push_back({U, I});
        I++;
    }

    for(int U = 0; U < N; U++)
    {
        if(!VisitedVertex[U])
        {
            Dfs(U);
        }
    }

    for(auto& U : Order)
    {
        for(int Bit = 0; Bit < 14; Bit++)
        {
            if((U & Power[Bit]))
            {
                Data.push_back(true);
            }
            else
            {
                Data.push_back(false);
            }
        }
    }

    return Data;
}

vector<pair<int, int>> decode(int N, vector<bool> Data)
{
    vector<pair<int, int>> Edges;    vector<int> Power(15, 0);
    Power[0] = 1;
    for(int i = 1; i < 14; i++) Power[i] = Power[i - 1] * 2;
    int U = 0;

    for(int i = 13; i < (int)Data.size(); i += 14)
    {
        int V = 0;
        int Start = i - 13;

        for(int Bit = 0; Bit < 14; Bit++)
        {
            if(Data[Start]) V += Power[Bit];
            Start++;
        }

        if(U > 0 && V > 0) Edges.push_back({U - 1, V - 1});
        U = V;
    }

    return Edges;
}

