# define _GLIBCXX_FILESYSTEM
# include "cactus.h"
# include <bits/stdc++.h>
using namespace std;

const int MAXN = 16001;

vector<bool> encode(int N, vector<pair<int, int>> Edges)
{
    vector<bool> Data;
    vector<int> Power(15, 0);
    Power[0] = 1;
    for(int i = 1; i < 14; i++) Power[i] = Power[i - 1] * 2;
    vector<int> Graph[MAXN];

    for(auto& [U, V] : Edges)
    {
        if(U > V) swap(U, V);
        U++;
        V++;
        Graph[U].push_back(V);
    }

    for(int U = 0; U < N; U++)
    {
        if(Graph[U].empty()) continue;

        for(int i = 0; i < 14; i++) Data.push_back(false);
        for(int Bit = 0; Bit < 14; Bit++)
        {
            if((U & Power[Bit]))
            {
                Data.push_back(true);
            }
            else
            {
                Data.push_back(false);
            }
        }

        for(auto& V : Graph[U])
        {
            for(int Bit = 0; Bit < 14; Bit++)
            {
                if((V & Power[Bit]))
                {
                    Data.push_back(true);
                }
                else
                {
                    Data.push_back(false);
                }
            }
        }
    }

    return Data;
}

vector<pair<int, int>> decode(int N, vector<bool> Data)
{
    vector<pair<int, int>> Edges;
    vector<int> Power(15, 0);
    Power[0] = 1;
    for(int i = 1; i < 14; i++) Power[i] = Power[i - 1] * 2;
    int Leader = -1;

    for(int i = 13; i < (int)Data.size(); i += 14)
    {
        int Start = i - 13;
        int U = 0;

        for(int Bit = 0; Bit < 14; Bit++)
        {
            if(Data[Start]) U += Power[Bit];
            Start++;
        }

        if(U == 0)
        {
            Leader = -1;
            continue;
        }

        if(Leader == -1)
        {
            Leader = U;
            continue;
        }

        Edges.push_back({Leader - 1, U - 1});
    }

    return Edges;
}

