#include "cactus.h"
#include <bits/stdc++.h>

using namespace std;

const int MAXN = 16000 + 5;

int n,inf;
int used[MAXN],par[MAXN];
vector<int>g[MAXN],z[MAXN];

void dfs(int beg, int p)
{
    used[beg] = 1;
    par[beg] = p;
    for(int nb : g[beg]) if(used[nb]==-1) dfs(nb,beg);
}

void pre()
{
    for(int i = 0; i < n; i++) used[i] = par[i] = -1;
    for(int i = 0; i < n; i++) g[i].clear();
}

void dopul(vector<bool>&res, int ch)
{
    for(int j = 0; j < 14; j++)
    {
        if(ch&(1<<j)) res.push_back(1);
        else res.push_back(0);
    }
}

vector<bool>res;
pair<int,int>kr;

void dfs1(int beg, int p, int dep)
{
    if(dep > kr.second) kr = {beg,dep};
    used[beg] = 1;
    for(int nb : z[beg]) if(nb != p) dfs1(nb,beg,dep+1);
}

void dfs_path(int beg, int p, int dep)
{
    if(dep > kr.second) kr = {beg,dep};

    par[beg] = p;
    for(int nb : z[beg]) if(nb != p) dfs_path(nb,beg,dep+1);
}

void MAH_z(int x, int y)
{
    vector<int>pom;

    for(int i = 0; i < z[x].size(); i++)
    {
        if(z[x][i] != y) pom.push_back(z[x][i]);
    }
    z[x] = pom;
    pom.clear();

    for(int i = 0; i < z[y].size(); i++)
    {
        if(z[y][i] != x) pom.push_back(z[y][i]);
    }
    z[y] = pom;
}

bool try_find(int k)
{
    for(int i = 0; i < n; i++) used[i] = -1;

    for(int i = 0; i < n; i++)
    {
        if(used[i] == -1)
        {
            kr = {-1,-1};
            dfs1(i,i,0);
            if(kr.first == i) continue;

            int x = kr.first;
            kr = {-1,-1};
            dfs_path(x,x,0);

            int y = kr.first;
            if(k != 1) dopul(res,inf);///za da ima inf pomejdu verijkite
            while(y != par[y])
            {
                dopul(res,y);
                MAH_z(y,y[par]);
                y = par[y];
            }
            dopul(res,y);
            return true;
        }
    }
    return false;
}

std::vector<bool> encode(int N, std::vector<std::pair<int, int>> edges)
{
    inf = (1<<14)-1;

    n = N;
    pre();

    for(pair<int,int> p : edges)
    {
        g[p.first].push_back(p.second);
        g[p.second].push_back(p.first);
    }
    //cout << "prog dfs" << endl;

    dfs(0,-1);
    //cout << "prog dfs2" << endl;

    res.clear();
    for(int i = 1; i < n; i++) dopul(res,par[i]);

    //cout << "preg af durvo" << endl;
    for(int i = 0; i < n; i++) z[i].clear();
    for(pair<int,int> p : edges)
    {
        int x = p.first;
        int y = p.second;
        if(par[x] != y && par[y] != x)
        {
            z[x].push_back(y);
            z[y].push_back(x);
        }
    }
    for(int k = 1; k <= n; k++)
    {
        if(!try_find(k)) break;
    }
    //cout << "prog af edges" << endl;

    return res;
}


int get_kr(vector<bool>&nach)
{
    int chis = 0;
    for(int j = 0; j < 14; j++)
    {
        if(nach.back()) chis += (1<<j);
        nach.pop_back();
    }
    return chis;
}

std::vector<std::pair<int, int>> decode(int N, std::vector<bool> data)
{
    inf = (1<<14)-1;
    n = N;
    vector<bool>nach = data;
    reverse(nach.begin(),nach.end());

    vector<pair<int,int> >ans;
    for(int i = 1; i < n; i++)
    {
        int p = get_kr(nach);
        ans.push_back({i,p});
    }

    int sz = (nach.size()) / 14;
    int last = inf;

    for(int i = 0; i < sz; i++)
    {
        int x = get_kr(nach);
        if(last != inf && x != inf) ans.push_back({last,x});
        last = x;
    }
    return ans;
}
