#include "cactus.h"
#include <bits/stdc++.h>

using namespace std;

const int MAXN = 16000 + 5;

int n;
int used[MAXN],par[MAXN];
vector<int>g[MAXN];

void dfs(int beg, int p)
{
    used[beg] = 1;
    par[beg] = p;
    for(int nb : g[beg]) if(used[nb]==-1) dfs(nb,beg);
}

void pre()
{
    for(int i = 0; i < n; i++) used[i] = par[i] = -1;
    for(int i = 0; i < n; i++) g[i].clear();
}

void dopul(vector<bool>&res, int ch)
{
    for(int j = 0; j < 14; j++)
    {
        if(ch&(1<<j)) res.push_back(1);
        else res.push_back(0);
    }
}

std::vector<bool> encode(int N, std::vector<std::pair<int, int>> edges)
{
    n = N;
    pre();

    for(pair<int,int> p : edges)
    {
        g[p.first].push_back(p.second);
        g[p.second].push_back(p.first);
    }
    //cout << "prog dfs" << endl;

    dfs(0,-1);
    //cout << "prog dfs2" << endl;

    vector<bool>res;
    for(int i = 1; i < n; i++) dopul(res,par[i]);

    //cout << "preg af durvo" << endl;
    for(pair<int,int> p : edges)
    {
        int x = p.first;
        int y = p.second;
        if(par[x] != y && par[y] != x)
        {
            dopul(res,x);
            dopul(res,y);
        }
    }
    //cout << "prog af edges" << endl;
    return res;
}


int get_kr(vector<bool>&nach)
{
    int chis = 0;
    for(int j = 0; j < 14; j++)
    {
        if(nach.back()) chis += (1<<j);
        nach.pop_back();
    }
    return chis;
}

std::vector<std::pair<int, int>> decode(int N, std::vector<bool> data)
{
    n = N;
    vector<bool>nach = data;
    reverse(nach.begin(),nach.end());

    vector<pair<int,int> >ans;
    for(int i = 1; i < n; i++)
    {
        int p = get_kr(nach);
        ans.push_back({i,p});
    }

    int sz = (nach.size()) / 14;
    for(int i = 0; i < sz; i += 2)
    {
        int x = get_kr(nach);
        int y = get_kr(nach);
        ans.push_back({x,y});
    }
    return ans;
}
