#include "cactus.h"
#include <bits/stdc++.h>

using namespace std;

const int MAXN = (1<<14);

int n;
int used[MAXN],par[MAXN];
vector<int>g[MAXN];

void dfs(int beg, int p)
{
    par[beg] = p;
    for(int nb : g[beg]) if(used[nb]==-1) dfs(nb,beg);
}

void pre()
{
    for(int i = 0; i < n; i++) used[i] = par[i] = -1;
    for(int i = 0; i < n; i++) g[i].clear();
}

void dopul(bool res[], int &idx, int ch)
{
    for(int j = 0; j < 14; j++)
    {
        if(ch&(1<<j))
        {
            res[idx] = true;
            idx++;
        }
        else
        {
            res[idx] = false;
            idx++;
        }
    }
}

std::vector<bool> encode(int N, std::vector<std::pair<int, int>> edges)
{
    n = N;
    pre();

    for(pair<int,int> p : edges)
    {
        g[p.first].push_back(p.second);
        g[p.second].push_back(p.first);
    }

    dfs(0,-1);

    bool *res = new bool[MAXN*28];
    int idx = 0;
    for(int i = 1; i < n; i++)
    {
        dopul(res,idx,par[i]);
    }

    for(pair<int,int> p : edges)
    {
        int x = p.first;
        int y = p.second;
        if(par[x] != y && par[y] == x)
        {
            dopul(res,idx,x);
            dopul(res,idx,y);
        }
    }

    vector<bool>v;
    for(int i = 0; i < idx; i++) v.push_back(res[i]);
    return v;
}


int get_kr(bool nach[], int &idx)
{
    int chis = 0;
    for(int j = 0; j < 14; j++)
    {
        if(nach[idx-1]) chis += (1<<j);
        idx--;
    }
    return chis;
}

std::vector<std::pair<int, int>> decode(int N, std::vector<bool> data)
{
    n = N;
    bool *nach = new bool[MAXN*28];
    int idx = data.size();

    for(int i = 0; i < data.size(); i++) nach[i] = data[i];
    reverse(nach,nach+idx);

    vector<pair<int,int> >ans;
    for(int i = 1; i < n; i++)
    {
        int p = get_kr(nach,idx);
        ans.push_back({i,p});
    }

    int sz = (idx) / 14;
    for(int i = 0; i < sz; i += 2)
    {
        int x = get_kr(nach,idx);
        int y = get_kr(nach,idx);
        ans.push_back({x,y});
    }
    return ans;
}
