#include "cactus.h"
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int maxn = 16005;

vector<bool> encode(int n, vector<pair<int, int>> edges)
{
    vector<bool> curr;

    for (auto [x, y] : edges)
    {
        for (int i = 13; i >= 0; --i)
        {
            curr.push_back((x & (1 << i)) != 0);
        }

        for (int i = 13; i >= 0; --i)
        {
            curr.push_back((y & (1 << i)) != 0);
        }
    }

    return curr;
}

vector<pair<int, int>> decode(int n, vector<bool> data)
{
    vector<pair<int, int>> edges;

    for (int i = 0; i < data.size(); i += 28)
    {
        int pw = (1 << 13);
        int x = 0, y = 0;

        for (int j = i; j <= i + 13; ++j)
        {
            x += pw * data[j];
            pw >>= 1;
        }

        pw = (1 << 13);

        for (int j = i + 14; j <= i + 27; ++j)
        {
            y += pw * data[j];
            pw >>= 1;
        }

        edges.push_back({x, y});
    }

    return edges;
}
