#include <iostream>

using namespace std;

const int maxn = 2005;
const long long inf = (1LL << 60);

int n;
int a[maxn];
long long dp[maxn][maxn / 2];
long long prefDp[maxn][maxn / 2];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
    }

    int maxK = n / 2;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= maxK; ++j)
        {
            dp[i][j] = -inf;
        }
    }

    for (int i = 1; i <= maxK; ++i)
    {
        prefDp[0][i] = -inf;
    }

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= maxK; ++j)
        {
            for (int prv = 0; prv <= i - 2; ++prv)
            {
                //cout << "now " << i << " " << j << " " << dp[prv][j - 1] << " + " << a[i] << " - " << a[prv + 1] << endl;
                dp[i][j] = max(dp[i][j], prefDp[prv][j - 1] + a[i] - a[prv + 1]);
            }

            prefDp[i][j] = max(prefDp[i - 1][j], dp[i][j]);

            //cout << i << " " << j << " :: " << dp[i][j] << endl;
        }
    }

    long long ans = -inf;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            ans = max(ans, dp[j][i]);
        }

        cout << ans << " ";
    }

    cout << endl;

    return 0;
}
