#include <iostream>

using namespace std;

const long long mod = 1e9 + 7;

int n;
long long p, q;
string s;

long long fastPower(long long a, long long b)
{
    long long curr = a, result = 1;

    for (int i = 0; i < 63; ++i)
    {
        if ((b & (1LL << i)) != 0)
        {
            result *= curr;
            result %= mod;
        }

        curr *= curr;
        curr %= mod;
    }

    return result;
}

long long E[3005];
long long pInv, qInv;
long long prob[2];
long long prefProb[3005];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> p >> q;
    cin >> s;

    pInv = fastPower(p, mod - 2);
    qInv = fastPower(q, mod - 2);
    prob[0] = (p * qInv) % mod;
    prob[1] = ((q - p) * qInv) % mod;

    long long sum = 0;
    long long oth = 0;

    prefProb[0] = prob[(s[0] - '0')];

    for (int i = 1; i < n; ++i)
    {
        prefProb[i] = (prefProb[i - 1] * prob[(s[i] - '0')]) % mod;
    }

    sum = prob[1 - (s[0] - '0')];
    sum %= mod;
    oth = sum;

    //cout << prob[0] << " " << 3 * fastPower(4, mod - 2) % mod << endl;
    //cout << prob[1] << " " << 1 * fastPower(4, mod - 2) % mod << endl;

    for (int i = 1; i <= n - 1; ++i)
    {
        long long good = prefProb[i - 1];
        long long bad = prob[1 - (s[i] - '0')];
        sum += (((good * bad) % mod) * (1LL * (i + 1))) % mod;
        oth += (good * bad) % mod;
        oth %= mod;
    }

    oth = (1 + mod - oth);
    oth %= mod;

    sum += ((1LL * n) * prefProb[n - 1]) % mod;
    sum %= mod;
    //cout << sum << " " << oth << endl;
    cout << (sum * fastPower(oth, mod - 2)) % mod << endl;

    return 0;
}
