#define _GLIBCXX_FILESYSTEM
#include "cactus.h"
#include <bits/stdc++.h>
using namespace std;

vector<bool> encode(int n, vector<pair<int, int>> v)
{
    int m = v.size();
    vector<bool> x;
    while (m > 0)
    {
        x.push_back(m % 2);
        m /= 2;
    }
    while (x.size() < 30)
        x.push_back(0);
    vector<bool> p;
    for (int i = 0; i < v.size(); i++)
    {
        p.clear();
        m = v[i].first;
        while (m > 0)
        {
            p.push_back(m % 2);
            m /= 2;
        }
        while (p.size() < 14)
            p.push_back(0);
        for (int j = 0; j < p.size(); j++)
            x.push_back(p[j]);
        p.clear();
        m = v[i].second;
        while (m > 0)
        {
            p.push_back(m % 2);
            m /= 2;
        }
        while (p.size() < 14)
            p.push_back(0);
        for (int j = 0; j < p.size(); j++)
            x.push_back(p[j]);
    }
    return x;
}

vector<pair<int, int>> decode(int n, vector<bool> b)
{
    vector<pair<int, int>> v;
    int m = 0;
    for (int i = 0; i <= 30; i++)
    {
        if (b[i])
            m += (1 << i);
    }
    int i1, i2, o;
    for (int i = 1; i <= 2 * m; i += 2)
    {
        i1 = o = 0;
        for (int j = 30 + (i - 1) * 14; j < 30 + i * 14; j++)
        {
            if (j > b.size())
                continue;
            if (b[j] == 1)
                i1 += (1 << o);
            o++;
        }
        i2 = o = 0;
        for (int j = 30 + i * 14; j < 30 + (i + 1) * 14; j++)
        {
            if (j > b.size())
                continue;
            if (b[j] == 1)
                i2 += (1 << o);
            o++;
        }
        v.push_back({i1, i2});
    }
    return v;
}

static void runTest()
{
    int n, m;
    std::vector<std::pair<int, int>> edges;

    std::cin >> n >> m;

    for (int i = 0; i < m; ++i)
    {
        int u, v;
        std::cin >> u >> v;
        edges.push_back({u, v});
    }

    std::vector<bool> data = encode(n, edges);

    std::vector<std::pair<int, int>> edgesGuess = decode(n, data);

    for (auto &[u, v] : edges)
    {
        if (u > v)
            std::swap(u, v);
    }
    std::sort(edges.begin(), edges.end());

    for (auto &[u, v] : edgesGuess)
    {
        if (u > v)
            std::swap(u, v);
    }
    std::sort(edgesGuess.begin(), edgesGuess.end());

    if (edgesGuess == edges)
    {
        std::cout << data.size() << std::endl;
    }
    else
    {
        std::cerr << "Wrong answer" << std::endl;
    }
}

int main()
{
    int t;
    std::cin >> t;

    for (int i = 0; i < t; i++)
    {
        runTest();
    }

    return 0;
}
