#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>

std::vector <bool> encode(int n, std::vector <std::pair <int ,int>> edges) {
    std::vector <bool> res;
    std::vector <std::vector <int>> susedi(n);

    for (int i = 0; i < edges.size(); i++) {
        susedi[edges[i].first].push_back(edges[i].second);
        susedi[edges[i].second].push_back(edges[i].first);
    }

    std::queue <int> current;
    std::vector <bool> explored(n); for (int i = 0; i < n; i++) explored[i] = false;

    current.push(0);
    while (!current.empty()) {
        int top = current.front(); current.pop(); explored[top] = true;
        for (int b = 0; b < 14; b++) {
            res.push_back(top & (1 << b));
        }
        int q = 0;
        for (int i: susedi[top]) {
            if (explored[i]) continue;
            current.push(i); q++;
        }
        for (int b = 0; b < 14; b++) {
            res.push_back(q & (1 << b));
        }
    }

    return res;
}

std::vector <std::pair <int, int>> decode(int n, std::vector <bool> data) {
    std::vector <std::pair <int, int>> res;
    int ind1 = 0;
    int ind2 = 0;

    for (int i = 0; i < data.size(); i += 28) {
        int num1 = 0, num2 = 0;
        for (int b = 0; b < 14; b++) {
            num1 |= data[i+b] << b;
        }
        for (int b = 0; b < 14; b++) {
            num2 |= data[i+b+14] << b;
        }

        for (int j = 0; j < num2; j++) {
            int num = 0;
            for (int b = 0; b < 14; b++) {
                num |= data[i+b+j*28+28] << b;
            }
            res.push_back({num1, num});
        }
    }

    return res;
}