#include <algorithm>
#include <iostream>
#include <vector>

std::vector <bool> encode(int n, std::vector <std::pair <int ,int>> edges) {
    std::vector <bool> res;
    std::vector <std::vector <int>> susedi(n);

    for (int i = 0; i < edges.size(); i++) {
        if (edges[i].first < edges[i].second) {
            susedi[edges[i].first].push_back(edges[i].second);
        } else {
            susedi[edges[i].second].push_back(edges[i].first);
        }
    }

    int i = 0;
    while (i < n) {
        for (int j: susedi[i]) {
            for (int b = 0; b < 15; b++) {
                res.push_back(j & (1 << b));
            }
        }

        int num_skip = 1; i++;
        while (susedi[i].size() == 0) { i++; num_skip++; }
        for (int b = 0; b < 15; b++) {
            res.push_back((16100+num_skip) & (1 << b));
        }
    }

    return res;
}

std::vector <std::pair <int, int>> decode(int n, std::vector <bool> data) {
    std::vector <std::pair <int, int>> res;
    int edge_ind = 0;

    for (int i = 0; i < data.size(); i += 15) {
        int num = 0;
        for (int b = 0; b < 15; b++) {
            num  |= data[i+b] << b;
        }
        if (num >= 16100) {
            edge_ind += num - 16100;
        }
        else {
            res.push_back({ edge_ind, num });
        }
    }

    return res;
}