#include <algorithm>
#include <iostream>
#include <vector>

std::vector <bool> encode(int n, std::vector <std::pair <int ,int>> edges) {
    std::vector <bool> res;
    std::vector <std::vector <int>> susedi(n);

    for (int i = 0; i < edges.size(); i++) {
        if (edges[i].first < edges[i].second) {
            susedi[edges[i].first].push_back(edges[i].second);
        } else {
            susedi[edges[i].second].push_back(edges[i].first);
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j: susedi[i]) {
            for (int b = 0; b < 14; b++) {
                res.push_back(j & (1 << b));
            }
        }
        for (int b = 0; b < 14; b++) {
            res.push_back(1);
        }
    }

    return res;
}

std::vector <std::pair <int, int>> decode(int n, std::vector <bool> data) {
    std::vector <std::pair <int, int>> res;
    int edge_ind = 0;

    for (int i = 0; i < data.size(); i += 14) {
        int num = 0;
        for (int b = 0; b < 14; b++) {
            num  |= data[i+b] << b;
        }
        if (num == 16383) {
            edge_ind++;
        }
        else {
            res.push_back({ edge_ind, num });
        }
    }

    return res;
}