#include <algorithm>
#include <iostream>
#include <vector>

std::vector <bool> encode(int n, std::vector <std::pair <int ,int>> edges) {
    std::vector <bool> res;
    for (int i = 0; i < edges.size(); i++) {
        for (int b = 0; b < 16; b++) {
            res.push_back(edges[i].first & (1 << b));
        }
        for (int b = 0; b < 16; b++) {
            res.push_back(edges[i].second & (1 << b));
        }
    }

    return res;
}

std::vector <std::pair <int, int>> decode(int n, std::vector <bool> data) {
    std::vector <std::pair <int, int>> res;

    for (int i = 0; i < data.size(); i += 32) {
        int num1 = 0, num2 = 0;
        for (int b = 0; b < 16; b++) {
            num1 |= data[i+b] << b;
        }
        for (int b = 0; b < 16; b++) {
            num2 |= data[i+b+16] << b;
        }
        res.push_back({ num1, num2 });
    }

    return res;
}