#include <bits/stdc++.h>

const int MAX_N = 16007;

std::vector<bool> bit15encode(int num){
    std::vector<bool> ans;
    while(num > 0){
        ans.push_back(num % 2);
        num /= 2;
    }
    while(ans.size() < 15){
        ans.push_back(false);
    }
    return ans;
}

int bit15decode(std::vector<bool> num){
    int ans = 0;
    int mult = 1;
    for(int i = 0; i < num.size(); i ++){
        ans += mult*num[i];
        mult *= 2;
    }
    return ans;
}



std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges){
    std::vector<bool> answer;
    std::vector<bool> endedge = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
    std::vector<int> a[MAX_N];
    for(int i = 0; i < edges.size(); i++){
        int x = edges[i].first;
        int y = edges[i].second;
        if(x > y){
            std::swap(x, y);
        }
        a[x].push_back(y);
    }
    for(int i = 0; i < MAX_N; i++){
        //std::cout << "i: " << i << " " << a[i].size() << std::endl;
        for(int j = 0; j < a[i].size(); j++){
            std::vector<bool> encoded = bit15encode(a[i][j]);
            for(int q = 0; q < encoded.size(); q++){
                answer.push_back(encoded[q]);
            }
        }
        for(int q = 0; q < endedge.size(); q++){
            answer.push_back(endedge[q]);
        }
    }

    return answer;
}


std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data){
    std::vector<std::pair<int, int>> answer;
    std::vector<bool> endedge = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
    std::vector<int> a[MAX_N];
    int idx = 0;
    for(int i = 0; i < data.size(); i += 15){
        std::vector<bool> curr;
        curr.resize(15);
        for(int j = 0; j < 15; j++){
            curr[j] = data[i + j];
        }
        //std::cout << idx << " ";
        for(int i = 0; i < curr.size(); i++){
            //std::cout << curr[i];
        }
        //std::cout << " ";
        if(curr == endedge){
            //std::cout << std::endl;
            idx++;
        }else{
            a[idx].push_back(bit15decode(curr));
        }
    }
    for(int i = 0; i < MAX_N; i++){
        for(int j = 0; j < a[i].size(); j++){
            answer.push_back({i, a[i][j]});
        }
    }
    /*
    for(int i = 0; i < 100; i++){
        std::cout << answer[i].first << " " << answer[i].second << std::endl;
    }
    */
    return answer;
}
