#include "cactus.h"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 16000 + 10;
const int MAXG = 5;

vector < bool > c[5];

vector < pair < int, int > > edg;
set < int > adj[MAXN];
int deg[MAXN];
bool used[MAXN];
pair < int, int > ord[MAXN];

void encodeNum(int num, int idx)
{
    for(int i = 0; i <= 13; i++)
    {
        c[idx].push_back((num >> i) & 1);
    }
}

void encodeNode(int node, int idx)
{
    c[idx].push_back(1);
    encodeNum(node, idx);

    for(auto nb : adj[node])
    {
        if(used[nb])
            continue;

        c[idx].push_back(0);
        encodeNum(nb, idx);
        adj[nb].erase(node);
    }
}

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    for(int i = 0; i < 5; i++)
    {
        c[i].clear();
    }

    for(int i = 0; i < n; i++)
    {
        deg[i] = 0;
        used[i] = 0;
    }

    for(pair < int, int > &e : edges)
    {
        deg[e.first]++;
        deg[e.second]++;
    }

    for(int i = 0; i < n; i++)
    {
        ord[i] = {-deg[i], i};
    }

    sort(ord, ord + n);

    for(pair < int, int > &e : edges)
    {
        adj[e.first].insert(e.second);
        adj[e.second].insert(e.first);
    }

    for(int i = 0; i < n; i++)
    {
        /**
        cout << "Node : " << ord[i].second << endl;
        cout << "Degree : " << -ord[i].first << endl;
        cout << endl;
        */
        int node = ord[i].second;

        used[node] = 1;

        encodeNode(node, 0);
        adj[node].clear();
    }

    return c[0];
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    edg.clear();

    int len = data.size();

    int ptr = 0;
    int node = -1;

    while(ptr < len)
    {
        bool check = data[ptr++];

        int cur = 0;

        for(int i = 0; i <= 13; i++)
        {
            cur += data[ptr++] * (1 << i);
        }

        if(check == 1)
        {
            node = cur;
        }
        else
        {
            edg.push_back({node, cur});
        }
    }

    return edg;
}
