#include "cactus.h"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 16000 + 10;

vector < bool > c;

vector < pair < int, int > > edg;
vector < int > adj[MAXN];

void encodeNum(int num)
{
    for(int i = 0; i <= 13; i++)
    {
        c.push_back((num >> i) & 1);
    }
}

void encodeNode(int node)
{
    if(adj[node].size() == 0)
        return;

    c.push_back(1);
    encodeNum(node);

    for(int nb : adj[node])
    {
        c.push_back(0);
        encodeNum(nb);
    }
}

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    c.clear();

    for(pair < int, int > &e : edges)
    {
        if(adj[e.first].size() <= adj[e.second].size())
            swap(e.first, e.second);

        adj[e.first].push_back(e.second);
    }

    for(int i = 0; i < n; i++)
    {
        encodeNode(i);
        adj[i].clear();
    }

    return c;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    edg.clear();

    int len = data.size();

    int ptr = 0;
    int node = -1;

    while(ptr < len)
    {
        bool check = data[ptr++];

        int cur = 0;

        for(int i = 0; i <= 13; i++)
        {
            cur += data[ptr++] * (1 << i);
        }

        if(check == 1)
        {
            node = cur;
        }
        else
        {
            edg.push_back({node, cur});
        }
    }

    return edg;
}
