#include "cactus.h"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 16000 + 10;

vector < bool > c;

vector < pair < int, int > > edg;
vector < int > adj[MAXN];

void encodeNum(int num)
{
    for(int i = 0; i <= 13; i++)
    {
        c.push_back((num >> i) & 1);
    }
}

void encodeNode(int node)
{
    int sz = adj[node].size();

    if(sz == 0)
        return;

    encodeNum(node);
    encodeNum(sz);

    for(int nb : adj[node])
    {
        encodeNum(nb);
    }
}

std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    c.clear();

    for(pair < int, int > &e : edges)
    {
        if(e.first > e.second)
            swap(e.first, e.second);

        adj[e.first].push_back(e.second);
    }

    for(int i = 0; i < n; i++)
    {
        encodeNode(i);
        adj[i].clear();
    }

    return c;
}

std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    edg.clear();

    int len = data.size();

    int ptr = 0;

    while(ptr < len)
    {
        int node = 0;
        for(int i = 0; i <= 13; i++)
        {
            node += data[ptr] * (1 << i);
            ptr++;
        }

        int sz = 0;
        for(int i = 0; i <= 13; i++)
        {
            sz += data[ptr] * (1 << i);
            ptr++;
        }

        for(int j = 0; j < sz; j++)
        {
            int nb = 0;
            for(int i = 0; i <= 13; i++)
            {
                nb += data[ptr] * (1 << i);
                ptr++;
            }

            edg.push_back({node, nb});
        }
    }

    return edg;
}
