#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 1e4 + 10;
const ll INF = 4e18 + 10;

int n;
ll a[MAXN];

struct SegmentTree
{
    ll tree[4 * MAXN];
    ll tree2[4 * MAXN];

    void update(int left, int right, int idx, int pos, ll val)
    {
        if(pos < left || right < pos)
            return;

        if(left == right)
        {
            tree[idx] = val - a[left];
            tree2[idx] = val;
            return;
        }

        int mid = left + (right - left) / 2;

        update(left, mid, 2 * idx, pos, val);
        update(mid + 1, right, 2 * idx + 1, pos, val);

        tree[idx] = max(tree[2 * idx], tree[2 * idx + 1]);
        tree2[idx] = max(tree2[2 * idx], tree2[2 * idx + 1]);
    }

    ll query(int left, int right, int idx, int qleft, int qright)
    {
        if(qright < left || right < qleft)
            return -INF;

        if(qleft <= left && right <= qright)
            return tree[idx];

        int mid = left + (right - left) / 2;

        ll Lnode = query(left, mid, 2 * idx, qleft, qright);
        ll Rnode = query(mid + 1, right, 2 * idx + 1, qleft, qright);

        return max(Lnode, Rnode);
    }

    ll query2(int left, int right, int idx, int pos)
    {
        if(pos == 0)
            return 0LL;

        if(pos < left || right < pos)
            return -INF;

        if(left == right)
            return tree2[idx];

        int mid = left + (right - left) / 2;

        ll Lnode = query2(left, mid, 2 * idx, pos);
        ll Rnode = query2(mid + 1, right, 2 * idx + 1, pos);

        return max(Lnode, Rnode);
    }

    void update(int pos, ll val)
    {
        update(1, n, 1, pos, val);
    }

    ll query(int left, int right)
    {
        return query(1, n, 1, left, right);
    }

    ll query2(int pos)
    {
        return query2(1, n, 1, pos);
    }

    void clean(int left, int right, int idx)
    {
        if(left == right)
        {
            tree[idx] = -a[left];
            tree2[idx] = 0LL;
            return;
        }

        int mid = left + (right - left) / 2;

        clean(left, mid, 2 * idx);
        clean(mid + 1, right, 2 * idx + 1);

        tree[idx] = max(tree[2 * idx], tree[2 * idx + 1]);
        tree2[idx] = max(tree2[2 * idx], tree2[2 * idx + 1]);
    }
};

SegmentTree dp[2];

ll ans[MAXN];

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }
}

void solve()
{
    dp[0].clean(1, n, 1);
    for(int j = 1; j <= n; j++)
    {
        ///cout << "For K = " << j << endl;

        for(int i = 1; i <= n; i++)
        {
            ///cout << "For i = " << i << endl;
            ll prv = dp[j & 1].query2(i - 1);

            dp[j & 1].update(i, prv);

            ///cout << "Stage 1 : " << dp[j & 1].query2(i) << endl;

            ll maxprv = dp[(j - 1) & 1].query(1, i - 1) + a[i];

            if(prv < maxprv)
                dp[j & 1].update(i, maxprv);

            ///cout << "Stage 2 : " << dp[j & 1].query2(i) << endl;
        }
        /**
        for(int i = 1; i <= n; i++)
        {
            cout << dp[j & 1].query2(i) << " ";
        }
        cout << endl << endl;
        */
        ans[j] = dp[j & 1].query2(n);
        dp[(j - 1) & 1].clean(1, n, 1);
    }

    for(int j = 1; j <= n; j++)
    {
        cout << ans[j] << " ";
    }
    cout << endl;
}

int main()
{
    read();
    solve();
    return 0;
}
