#include <bits/stdc++.h>
using namespace std;
const int BITS = 14;
string inbinary(int num)
{
    string ret = "";

    while (num)
    {
        char c = ((num&1) + '0');
        ret = c + ret;
        num >>= 1;
    }
    return ret;
}
string bfs(int s, vector<int> &degree, vector<vector<int>> &adj)
{
    queue<int> q;
    bitset<16008> used;
    q.push(s);
    used.set(s);
    string ret = "";
    while ( !q.empty() )
    {
        int curr = q.front();
        q.pop();
        cerr << "curr=" << curr << endl;
        ret += inbinary(curr);
        ret += inbinary(degree[curr]);

        for (auto next : adj[curr])
        {
            if ( !used.test(next) )
            {
                used.set(next);
                degree[next]--;
                q.push(next);
            }
        }
    }
    return ret;
}
std::vector<bool> encode(int n, std::vector<std::pair<int, int>> edges)
{
    /*int loglen[20000];
    loglen[ 1] = 0;
    for (int i=2; i<=n; i++)
    {
        loglen[i] = loglen[i/2] + 1;
    }
    /// loglen[n]++*/

    vector<int> degree(n+1, 0);

    int mind = n;
    vector<vector<int>> adj;
    adj.resize(n+1);
    degree[n] = 1e9;
    for (auto [a, b]: edges)
    {
        degree[a]++;
        degree[b]++;
        if ( degree[a] < degree[mind]) mind = a;
        if ( degree[a] < degree[mind]) mind = b;
        adj[a].push_back(b); /// opt
        adj[b].push_back(a); /// opt
    }



    string ret = bfs(mind, degree, adj);
    cerr<< "string ret = " << ret << endl;
    vector<bool> v(ret.size());
    for (int i=0; i<(int)ret.size(); i++)
    {
        if ( ret[i] == '0')  v[i] = 0;
        else v[i] = 1;
    }
    return v;
}
int binarytonum(vector<bool> b)
{
    int st = b.size();
    int ret = 0;
    for (int i=0; i<(int)b.size(); i++, st--)
    {
        if ( b[i])
            ret += (1<<st);
    }
    return ret;
}
int nextnum(int &ind,  vector<bool> &data)
{vector<bool> b;
    for (int k=ind; k<BITS; k++)
    {
        b.push_back( data[k] );
    }
    ind += BITS;
    int s = binarytonum(b);
    return s;
}
std::vector<std::pair<int, int>> decode(int n, std::vector<bool> data)
{
    vector<std::pair<int, int>> ret;

    int ind = 0;
    int s = nextnum(ind, data);

    queue<int> q;
    q.push(s);
    vector<int> degree(n+1, 0);
    degree[s] = nextnum(ind, data);

    while ( !q.empty() )
    {
        int curr = q.front();
        q.pop();

        for (int a=0; a < degree[curr]; a++)
        {
             int next = nextnum(ind, data);
             degree[next] = nextnum(ind, data);
             ret.push_back({curr, next});
             q.push(next);
        }
    }

    return ret;
}

