#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

vector<bool> two_nums_to_bool(int a, int b){
    unsigned long long num = (((1 << 15) + a) << 14) + b;
    vector<bool> cur;
    for(int i = 28; i > 0; --i){
        cur.push_back(num % 2);
        num >>= 1;
    }
    return cur;
}

vector<bool> num_to_bool(int a){
    if(a >= (1 << 14)){
        cout << "STUPID";
    }else{
        vector<bool> cur;
        for(int i = 14; i > 0; --i){
            cur.push_back(a % 2);
            a >>= 1;
        }
        //cout << a << "->"; for(bool c : cur){cout << c;} cout << endl;
        if(cur.size() != 14) cout << "STUPID";
        return cur;
    }
}

vector<bool> encode(int n, vector<pair<int, int>> edges){
    vector<int> adj_list[n];
    for(auto edge : edges){
        int u = edge.first, v = edge.second;
        if(v > u)adj_list[u].push_back(v);
        else adj_list[v].push_back(u);
    }

    /*for(int i = 0; i < n; ++i){
        cout << i << " " << adj_list[i].size() << ": " ;
        for(int v : adj_list[i]){
            cout << v << " ";
        }
        cout << endl;
    }*/

    vector<int> numbers_at_start, numbers_at_end;
    int sz = 0;
    for(int u = 0; u < n; ++u){
        if(adj_list[u].size() == 1){
            numbers_at_end.push_back(u);
            numbers_at_end.push_back(adj_list[u][0]);
        }else if(adj_list[u].size() != 0){
            numbers_at_start.push_back(u);
            numbers_at_start.push_back(adj_list[u].size());
            for(int v : adj_list[u]){
                numbers_at_start.push_back(v);
            }
            sz++;
        }
    }

   // cout << "ENCODE\n";
    vector<bool> ans, cur;
    //cout << "sz " << sz << "; ";
    cur = num_to_bool(sz);
    for(bool a : cur){
        ans.push_back(a);
    }
    for(int i = 0; i < numbers_at_start.size(); ++i){
            //cout << numbers_at_start[i] << " ";
        cur = num_to_bool(numbers_at_start[i]);
        for(bool a : cur){
            ans.push_back(a);
        }
    }
    //cout << "\nindividual edges ";
    for(int i = 0; i < numbers_at_end.size(); ++i){
        //cout << numbers_at_end[i] << " ";
        cur = num_to_bool(numbers_at_end[i]);
        for(bool a : cur){
            ans.push_back(a);
            //cout << a;
        }
    }
    //cout << endl;
    return ans;
}

pair<int, int> bool_to_two_nums(vector<bool> b){
    if(b.size() == 14 * 2){
        pair<int, int> ans = {0, 0};
        //for(bool a : b){ cout << a; } cout << "->";
        for(int i = 0; i < 14; ++i){
            ans.second = (ans.second << 1) + b[b.size() - 1];
            b.pop_back();
        }
        for(int i = 0; i < 14; ++i){
            ans.first = (ans.first << 1) + b[b.size() - 1];
            b.pop_back();
        }
        return ans;
    }else{
        cout << "STUPID";
    }
}

int bool_to_num(vector<bool> b){
    if(b.size() == 14){
        //for(bool a : b){ cout << a; } cout << "->";
        int ans = 0;
        for(int i = 0; i < 14; ++i){
            ans = (ans << 1) + b[b.size() - 1];
            b.pop_back();
        }
        return ans;
    }
}

vector<pair<int, int>> decode(int n, vector<bool> data){
    //cout << "DECODE\n";
    vector<pair<int, int>> ans;
    vector<bool> cur;

    // read sz
    for(int i = 0; i < 14; ++i){
        cur.push_back(data[i]);
    }
    int sz = bool_to_num(cur), at_bit = 14;
    cur.clear();
    //cout << "sz: " << sz << "\n";
    // read groups
    for(int i = 0; i < sz; ++i){
        // header
        for(int j = at_bit; j < at_bit + 28; ++j){
            cur.push_back(data[j]);
        }
        at_bit += 28;
        pair<int, int> smth = bool_to_two_nums(cur);
        cur.clear();
        int u = smth.first, u_adj_len = smth.second;
        //cout << "{" << u << ", " << u_adj_len << "} ";
        // we have to read u_adj_len numbers
        for(int k = 0; k < u_adj_len; ++k){
            for(int j = at_bit; j < at_bit + 14; ++j){
                cur.push_back(data[j]);
            }
            int v = bool_to_num(cur);
            //cout << v << ", ";
            cur.clear();
            ans.push_back({u, v});
            at_bit += 14;
        }
        //cout << endl;
    }
    // read individual edges
    for(; at_bit < data.size(); at_bit += 28){
        cur.clear();
        for(int i = at_bit; i < at_bit + 28; ++i){
            cur.push_back(data[i]);
        }
        pair<int, int> edge = bool_to_two_nums(cur);
        //cout << edge.first << " " << edge.second << endl;
        ans.push_back(edge);
    }
    return ans;
}
