#include<iostream>
#include<vector>
using namespace std;

const int MAX_N = 5e5;

int n, p[MAX_N], f = 0;
vector<int> deals[MAX_N];

void calculate_all_deals(){
    for(int i = 0; i < n; ++i){
        for(int j = i + 1; j < n; ++j){
            deals[i].push_back(max(0, p[j] - p[i]));
        }
    }
}

// [l, r]
pair<int, int> find_best_deal(int l, int r){
    pair<int, int> ans = {-1, -1};
    int best = 0;
    for(int i = l; i < r; ++i){
        for(int j = i + 1; j <= r; ++j){
            if(p[j] - p[i] > best){
                best = p[j] - p[i];
                ans = {i, j};
            }
        }
    }
    return ans;
}

// [start, n - 1]
long long subsets(int start, int remaining){
    long long ans = 0;
    if(start >= n) return 0;
    if(remaining <= 0){
        f++;
        return 0;
    }
    for(int i = start + 1; i < n; ++i){
        auto a = find_best_deal(start, i);
        if(a.second != i) continue;
        ans = max(ans, p[a.second] - p[a.first] + subsets(i + 1, remaining - 1));
    }
    return ans;
}

int main(){
   // ios_base::sync_with_stdio(false);
   // cin.tie(0); cout.tie(0);

    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> p[i];
    }
    calculate_all_deals();
    for(int k = 1; k <= n; ++k){
        cout << subsets(0, k)/* << " " << k << " " << f */<< " ";
    }
    return 0;
}
